#!/usr/bin/python
# -*- encoding: utf-8 -*-
###########################################################################
#    Module Writen to OpenERP, Open Source Management Solution
#    Copyright (C) OpenERP Venezuela (<http://openerp.com.ve>).
#    All Rights Reserved
###############Credits######################################################
#    Coded by: Angelica Barrios angelicaisabelb@gmail.com
#              Humberto Arocha humberto@openerp.com.ve
#    Planified by: Humberto Arocha
#    Finance by: LUBCAN COL S.A.S http://www.lubcancol.com
#    Audited by: Humberto Arocha humberto@openerp.com.ve
#############################################################################
#    This program is free software: you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation, either version 3 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program.  If not, see <http://www.gnu.org/licenses/>.
##############################################################################
from osv import osv
from osv import fields
from tools.translate import _
from tools import config
import time

class account_voucher(osv.osv):
    _inherit="account.voucher"
    _columns={
        'check_note_ids': fields.one2many('check.note', 'account_voucher_id', 'Cheques',readonly=False, required=False),     
        'payee_id':fields.many2one('res.partner.address','Beneficiario',required=False, readonly=False),
        'journal_id':fields.many2one('account.journal', 'Journal', required=False, readonly=True, states={'draft':[('readonly',False)]}),
        'account_id':fields.many2one('account.account', 'Account', required=False, readonly=True, states={'draft':[('readonly',False)]}, domain=[('type','<>','view')]),
        'voucher_pay_support_id':fields.many2one('voucher.pay.support', 'Orden de Pago', required=False, readonly=True),  
    } 
account_voucher()
    
class VoucherLine(osv.osv):
    _inherit = 'account.voucher.line'
    _defaults = {
        'type': lambda *a: 'dr'
    }  
    
    def onchange_invoice_id(self, cr, uid, ids, invoice_id, context={}):
        res = {}
        lines = []
        if 'lines' in self.voucher_context:
            lines = [x[2] for x in self.voucher_context['lines'] if x[2]]
        
        if not invoice_id:
            res = {
                'value':{ }
            }
        else:
            invoice_obj = self.pool.get('account.invoice').browse(cr, uid, invoice_id, context)
            residual = invoice_obj.residual
            same_invoice_amounts = [x['amount'] for x in lines if x['invoice_id']==invoice_id]
            residual -= sum(same_invoice_amounts)
            res = {
                'value' : {'amount':residual}
            }
        return res    
      
#    def onchange_line_account(self, cr, uid, ids, account_id, type, type1):
#        if not account_id:
#            return {'value' : {'account_id' : False, 'type' : False ,'amount':False}}
#        obj = self.pool.get('account.account')
#        acc_id = False
#        balance=0
#        print "lo que tiene type1 essssssssssssssssss",type1
#        if type1 in ('rec_voucher','bank_rec_voucher', 'journal_voucher'):
#            print "paso1"
#            acc_id = obj.browse(cr, uid, account_id)
#            balance = acc_id.credit
#            type = 'cr'
#        elif type1 in ('pay_voucher','bank_pay_voucher','cont_voucher') : 
#            print "paso2"
#            acc_id = obj.browse(cr, uid, account_id)
#            balance = acc_id.debit
#            type = 'dr'
#        elif type1 in ('journal_sale_vou') : 
#            print "paso3"
#            acc_id = obj.browse(cr, uid, account_id)
#            balance = acc_id.credit
#            type = 'dr'
#        elif type1 in ('journal_pur_voucher') : 
#            print "paso4"
#            acc_id = obj.browse(cr, uid, account_id)
#            balance = acc_id.debit
#            type = 'cr'
#        return {
#            'value' : {'type' : type, 'amount':balance}
#        } 
   
    def onchange_line_account(self, cr, uid, ids, account_id, type, type1):
        if not account_id:
            return {'value' : {'account_id' : False, 'type' : False ,'amount':False}}
        obj = self.pool.get('account.account')
        acc_id = False
        balance=0
        print "lo que tiene type1 essssssssssssssssss",type1
        if type in ('rec_voucher','bank_rec_voucher', 'journal_voucher'):
            print "paso1"
            acc_id = obj.browse(cr, uid, account_id)
            balance = acc_id.credit
            type = 'cr'
        elif type in ('pay_voucher','bank_pay_voucher','cont_voucher') : 
            print "paso2"
            acc_id = obj.browse(cr, uid, account_id)
            balance = acc_id.debit
            type = 'dr'
        elif type in ('journal_sale_vou') : 
            print "paso3"
            acc_id = obj.browse(cr, uid, account_id)
            balance = acc_id.credit
            type = 'dr'
        elif type in ('journal_pur_voucher') : 
            print "paso4"
            acc_id = obj.browse(cr, uid, account_id)
            balance = acc_id.debit
            type = 'cr'
        return {
            'value' : {'type' : type, 'amount':balance}
        }
        
        
             
VoucherLine()  
