# -*- encoding: utf-8 -*-
###########################################################################
#    Module Writen to OpenERP, Open Source Management Solution
#    Copyright (C) OpenERP Venezuela (<http://openerp.com.ve>).
#    All Rights Reserved
###############Credits######################################################
#    Coded by: Angelica Barrios angelicaisabelb@gmail.com
#              Humberto Arocha humberto@openerp.com.ve
#    Planified by: Humberto Arocha
#    Finance by: LUBCAN COL S.A.S http://www.lubcancol.com
#    Audited by: Humberto Arocha humberto@openerp.com.ve
#############################################################################
#    This program is free software: you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation, either version 3 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program.  If not, see <http://www.gnu.org/licenses/>.
##############################################################################

from osv import osv
from osv import fields
from tools.translate import _
from tools import config



class baremo_ciiu_item(osv.osv):
    _name = 'baremo.ciiu.item'
    _columns = {
    'name': fields.char('Descripcion', size=512, required=True, readonly=False)                                 ,
    'actividad_id':fields.many2one('baremo.ciiu.actividad', 'Actividades', required=True)                       ,
    'codigo': fields.integer('Codigo' , required=True, readonly=False)                                          ,  
    'tarifas_ids': fields.one2many('baremo.tarifa', 'id_linea', 'tarifas', required=True)                       ,
    'retencion_compra':fields.many2one('account.account','Cuenta de Compra', domain="[('type', '<>', 'view')]") ,
    'retencion_venta':fields.many2one('account.account','Cuenta de Venta', domain="[('type', '<>', 'view')]")   ,                
    } 
    
    def name_get(self,cr,uid,ids, context={}):
        if not len(ids):
            return []
        res = []
        for record in self.read(cr,uid,ids,['codigo'], context=context):
            res.append((record['id'],'CIIU %s'%record['codigo']))
        return res

    
    def _check_cod(self,cr,uid,ids,context={}):
        obj_baremo = self.browse(cr,uid,ids[0])
        codigo=obj_baremo.codigo
        print "el obj_baremo.codigo es: ",codigo
        cr.execute('select a.codigo  from baremo_ciiu_item a ')
        lista=cr.fetchall()
        print "la lista de los codigos es:",lista
        #comprension de lista
        bandera=([x[0] for x in lista if x[0] == codigo])
        #bandera devuelve una lista de las ocurrencias
        print"bandera es:", bandera
        if  len(bandera)>1 :
            return False
        return True

    _constraints = [
        (_check_cod, 'Error ! El codigo que introdujo ya se encuentra repetido en la lista de Actividades de Industria y Comercio. ', ['codigo'])
    ]
    
    
baremo_ciiu_item()



