# -*- encoding: utf-8 -*-
###########################################################################
#    Module Writen to OpenERP, Open Source Management Solution
#    Copyright (C) OpenERP Venezuela (<http://openerp.com.ve>).
#    All Rights Reserved
###############Credits######################################################
#    Coded by: Angelica Barrios angelicaisabelb@gmail.com
#              Humberto Arocha humberto@openerp.com.ve
#    Planified by: Humberto Arocha
#    Finance by: LUBCAN COL S.A.S http://www.lubcancol.com
#    Audited by: Humberto Arocha humberto@openerp.com.ve
#############################################################################
#    This program is free software: you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation, either version 3 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program.  If not, see <http://www.gnu.org/licenses/>.
##############################################################################

from osv import osv
from osv import fields
from tools.translate import _
from tools import config


class baremo_tarifa(osv.osv):
    _name = 'baremo.tarifa'
    _columns = {
    'name':fields.char('requisito', size=5, required=False, readonly=False)                               , 
    'id_linea':fields.many2one('baremo.ciiu.item', 'Actividades')                                         ,
    'id_ciudad': fields.many2one('res.country.state.city' ,'Ciudad', required=False, readonly=False)      , 
    'id_estado': fields.many2one('res.country.state','Departamento' , required=False, readonly=False)     ,  
    'id_pais': fields.many2one('res.country' , 'Pais', required=False, readonly=False)                    ,
    'tarifa': fields.float('Tarifa (%o.)' ,digits=(16,2) , required=True, readonly=False)                 ,                 
    }
    _defaults = {
        'tarifa': lambda *a: 0.0,
    }
    
    def _check_tar(self,cr,uid,ids,context={}):

        obj_baremo = self.browse(cr,uid,ids[0])
        ciudad=[]
        print "obj_baremo.id_ciudad.id ",obj_baremo.id_ciudad.id
        cr.execute('select a.id_ciudad  from baremo_tarifa a   where a.id_linea=%d'%(obj_baremo.id_linea))
        lista=cr.fetchall()
        print lista
        ci = self.pool.get('res.country.state.city')
        #comprension de lista
        bandera=([x[0] for x in lista if x[0] == obj_baremo.id_ciudad.id])
        #bandera devuelve una lista de las ocurrencias
        print"bandera es:", bandera
        if  len(bandera)>1 :
            return False
        return True

    _constraints = [
        (_check_tar, 'Error ! Esta Ciudad ya tiene una Tarifa Establecida. ', ['id_linea'])
    ]
    
baremo_tarifa()








