# -*- encoding: utf-8 -*-
###########################################################################
#    Module Writen to OpenERP, Open Source Management Solution
#    Copyright (C) OpenERP Venezuela (<http://openerp.com.ve>).
#    All Rights Reserved
###############Credits######################################################
#    Coded by: Angelica Barrios angelicaisabelb@gmail.com
#              Humberto Arocha humberto@openerp.com.ve
#    Planified by: Humberto Arocha
#    Finance by: LUBCAN COL S.A.S http://www.lubcancol.com
#    Audited by: Humberto Arocha humberto@openerp.com.ve
#############################################################################
#    This program is free software: you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation, either version 3 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program.  If not, see <http://www.gnu.org/licenses/>.
##############################################################################

from osv import osv
from osv import fields
from tools.translate import _
from tools import config

class account_invoice(osv.osv):
    _inherit = 'account.invoice'
    #~ Determinar el tipo de transaccion que estoy llevando a cabo
    #~ si es una venta o una compra, dependiendo de ello yo sere el vendedor,
    #~ o el comprador
    def _retener(self, cr, uid, ids, context=None):
        invoices = self.browse(cr, uid, ids, context=None)
        for inv in invoices:
            if inv.type == 'in_invoice' or inv.type == 'in_refund':
                #~ si estoy aqui dentro es porque soy un comprador,
                comprador = inv.company_id.partner_id.type.id
                per_comp = inv.company_id.partner_id.nat_jur # esta tambien hay que arreglarla
                vendedor = inv.partner_id.type.id 
                per_vend = inv.partner_id.nat_jur #hay que arreglar esta parte
                
            elif inv.type == 'out_invoice' or inv.type == 'out_refund':
                #~ si estoy aqui dentro es porque soy un vendedor, 
                comprador = inv.partner_id.type.id 
                per_comp = inv.partner_id.nat_jur 
                vendedor = inv.company_id.partner_id.type.id
                per_vend = inv.company_id.partner_id.nat_jur
            
            self._validar_Contribuyente(vendedor, comprador, per_comp, per_vend)

            #~ con estos dos datos se va al baremo donde se relacionan al vendedor y al comprador, y donde se determina
            #~ si a este vendedor se le debe aplicar retencion
            res = self._revisar_Baremo(cr, uid, vendedor, comprador)
            print 'res: ', res, '\n'
            if res['aplica_rta'] == True:
                self._retener_renta(cr, uid, ids, per_vend,context=None)
            if res['aplica_iva'] == True:
                pass
            
            if res['aplica_ica'] == True:
                pass
            
        return True
            
    def _validar_Contribuyente(self, vendedor, comprador, per_comp, per_vend):
        if vendedor== False:
            raise osv.except_osv(_('Atencion !'), _('Debe establecer el tipo de Contribuyente en la Pestaña del Vendedor !!!'))
            
        if comprador== False:
            raise osv.except_osv(_('Atencion !'), _('Debe establecer el tipo de Contribuyente en la Pestaña del Comprador !!!'))
        
        if per_vend== False:
            raise osv.except_osv(_('Atencion !'), _('Debe establecer el tipo de Persona en la Pestaña del Vendedor !!!'))
            
        if per_comp== False:
            raise osv.except_osv(_('Atencion !'), _('Debe establecer el tipo de Persona en la Pestaña del Comprador !!!'))
        
        return True
    def _revisar_Baremo(self, cr, uid, vendedor, comprador):
        #~ Obtengo los valores de la tabla de contribuyentes
        res = {}
        tabla_contribuyente = self.pool.get('tax_payer_supplier')
        t_ids = tabla_contribuyente.search(cr, uid, [('type','=',vendedor)], limit = 1)
        tipo_de_vendedor = tabla_contribuyente.browse(cr, uid, t_ids, context=None)
        vendedor_vale = False
        comprador_vale = False
        for cada_vendedor in tipo_de_vendedor:
            if cada_vendedor.type.id == vendedor:
                #~ si estoy aqui es porque este es el tipo de vendedor
                vendedor_vale = True
                for cada_comprador in cada_vendedor.retenedor_ids:
                    if cada_comprador.type.id == comprador:
                        comprador_vale = True
                        #~ si estoy aqui es porque este es el tipo de comprador
                        res['aplica_rta'] = cada_comprador.bool_renta
                        res['aplica_iva'] = cada_comprador.bool_iva
                        res['aplica_ica'] = cada_comprador.bool_ica
                        return res # cortamos aqui el ciclo porque ya hemos obtenido lo que deseabamos
                break # cortamos aqui el ciclo porque ya hemos obtenido lo que deseabamos
        
        contribuyente = self.pool.get('tax_payer')
        if vendedor_vale== False:
            raise osv.except_osv(_('Atencion !'), _('El tipo de Contribuyente del Vendedor [%s] \n no esta registrado en la Tabla de Contribuyentes, \n Vaya a la Tabla de Contribuyentes y registre dicho Tipo !!!')%(contribuyente.browse(cr, uid, vendedor).name))
            
        if comprador_vale== False:
            raise osv.except_osv(_('Atencion !'), _('El tipo de Contribuyente del Comprador [%s] \n no esta registrado en la Tabla de Contribuyentes, \n para el tipo de Vendedor [%s] de esta Factura \n Vaya a la Tabla de Contribuyentes y registre dicho Tipo !!!')%(contribuyente.browse(cr, uid, comprador).name,contribuyente.browse(cr, uid, vendedor).name))

        return res
    def _retener_renta(self, cr, uid, ids, per_vend, context=None):
        invoices = self.pool.get('account.invoice').browse(cr,uid,ids,context=None)
        ut = self.pool.get('l10n.ut')
        for invoice in invoices:
            ut_ids = ut.search(cr, uid, [('date','>=',invoice.date_invoice),('date','<',invoice.date_invoice),], limit = 1)
            print 'ut_ids', ut_ids, '\n'
            for items in invoice.invoice_line:
                if items.product_id.id != False:
                    print 'Tipo de Renta: ',items.product_id.reterenta.name, '\n'
                    print 'per_vend:', per_vend, '\n'
                    if per_vend == 'nat':   # El vendedor es una persona natural
                        # obtener la tabla de retenciones de este producto para la parte de persona natural
                        if items.product_id.reterenta.natural_ids != False:
                            for tarifa in items.product_id.reterenta.natural_ids:
                                print 'tarifa.base: ', tarifa.base,  '\n'
                                print 'tarifa.tarifa: ', tarifa.tarifa,  '\n'
                                #~  Aqui ya se puede incorporar el asunto de la unidad tributaria
                                #~ hacer las comparaciones respectivas para luego establecer cual es el total de impuesto
                                #~ a retener al vendedor y luego de tener todo listo hacer el respectivo comprobante contable
                                #~ de estas retenciones
                        else:
                            print 'Elevar mensaje para indicar que no hay una tarifa para esta persona natural en este elemento\n'
                    elif per_vend == 'jur': # El vendedor es una persona juridica
                        # obtener la tabla de retenciones de este producto para la parte de persona natural
                        if items.product_id.reterenta.juridico_ids != False:
                            for tarifa in items.product_id.reterenta.juridico_ids:
                                print 'tarifa.base: ', tarifa.base,  '\n'
                                print 'tarifa.tarifa: ', tarifa.tarifa,  '\n'
                                #~  Aqui ya se puede incorporar el asunto de la unidad tributaria
                                #~ hacer las comparaciones respectivas para luego establecer cual es el total de impuesto
                                #~ a retener al vendedor y luego de tener todo listo hacer el respectivo comprobante contable
                                #~ de estas retenciones
                        else:
                            print 'Elevar mensaje para indicar que no hay una tarifa para esta persona natural en este elemento\n'
                else:
                    print 'Este Item no esta asociado a un producto o servicio: ', items.name, '\n'
                    print 'Hay que elevar una aviso aqui, no puede haber items sin productos asociados\n'
        return True
account_invoice()
