# -*- encoding: utf-8 -*-
###########################################################################
#    Module Writen to OpenERP, Open Source Management Solution
#    Copyright (C) OpenERP Venezuela (<http://openerp.com.ve>).
#    All Rights Reserved
###############Credits######################################################
#    Coded by: Angelica Barrios angelicaisabelb@gmail.com
#              Humberto Arocha humberto@openerp.com.ve
#    Planified by: Humberto Arocha
#    Finance by: LUBCAN COL S.A.S http://www.lubcancol.com
#    Audited by: Humberto Arocha humberto@openerp.com.ve
#############################################################################
#    This program is free software: you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation, either version 3 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program.  If not, see <http://www.gnu.org/licenses/>.
##############################################################################


from osv import osv
from osv import fields
from tools.translate import _
from tools import config


class baremo_rent_item(osv.osv):
    """Clase donde se encuentran los items de las diferentes categorias de retencion, tambien se dispone de las claves foraneas de las otras clases de baremo"""
    _name = 'baremo.rent.item'
    _columns = {
    'name': fields.char('Concepto',size=256, required=True, readonly=False)                                         ,
    'categoria_id': fields.many2one('baremo.rent.category', 'Categoria',required=True)                              ,
    'natural_ids': fields.one2many('baremo.rent.natural', 'name', 'Tarifa Persona Natural', required=True)          ,
    'juridico_ids': fields.one2many('baremo.rent.legal', 'name', 'Tarifa Persona Juridica', required=True)          ,
    'retencion_compra':fields.many2one('account.account','Cuenta de Compra', domain="[('type', '<>', 'view')]" )    ,
    'retencion_venta':fields.many2one('account.account','Cuenta de Venta', domain="[('type', '<>', 'view')]")       ,
	}
baremo_rent_item()
