# -*- encoding: utf-8 -*-
###########################################################################
#    Module Writen to OpenERP, Open Source Management Solution
#    Copyright (C) OpenERP Venezuela (<http://openerp.com.ve>).
#    All Rights Reserved
###############Credits######################################################
#    Coded by: Angelica Barrios angelicaisabelb@gmail.com
#              Humberto Arocha humberto@openerp.com.ve
#    Planified by: Humberto Arocha
#    Finance by: LUBCAN COL S.A.S http://www.lubcancol.com
#    Audited by: Humberto Arocha humberto@openerp.com.ve
#############################################################################
#    This program is free software: you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation, either version 3 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program.  If not, see <http://www.gnu.org/licenses/>.
##############################################################################


from osv import osv
from osv import fields
from tools.translate import _
from tools import config

class baremo_rent_natural(osv.osv):
    """Clase que se relaciona con la tabla baremo_rent_item de acuerdo a las personas de tipo naturales"""
    _name = 'baremo.rent.natural'
    _order = 'base desc'
    _columns = {
    'name':fields.many2one('baremo.rent.item', 'Concepto')                        ,
    'base':fields.float('Base desde... (UVT)',digits=(16,2),required=True)        ,
    'tarifa':fields.float('Tarifa (%)',digits=(16,2),required=True)               ,    
    }
    _defaults = {
        'base': lambda *a: 0.0,
        'tarifa': lambda *a: 0.0,
    }
baremo_rent_natural()
