#!/usr/bin/python
# -*- encoding: utf-8 -*-
###########################################################################
#    Module Writen to OpenERP, Open Source Management Solution
#    Copyright (C) OpenERP Venezuela (<http://openerp.com.ve>).
#    All Rights Reserved
###############Credits######################################################
#    Coded by: Angelica Barrios angelicaisabelb@gmail.com
#              Humberto Arocha humberto@openerp.com.ve
#    Planified by: Humberto Arocha
#    Finance by: LUBCAN COL S.A.S http://www.lubcancol.com
#    Audited by: Humberto Arocha humberto@openerp.com.ve
#############################################################################
#    This program is free software: you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation, either version 3 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program.  If not, see <http://www.gnu.org/licenses/>.
##############################################################################
from osv import osv
from osv import fields
from tools.translate import _
from tools import config
import time
import datetime

class check_book_request(osv.osv):
    '''
    Modulo de Solicitud de Chequera
    '''
    _name='check.book.request'
    
    def copy(self, cr, uid, id, default=None, context=None):
        raise osv.except_osv(_('Atencion !'), _('No se puede duplicar este documento!!!'))
        return super(check_book_request, self).copy(cr, uid, id, {}, context)
    
    _columns={
    'code': fields.char('Num de Solicitud', size=60, readonly=True)                                                          , 
    'accounting_bank_id':fields.many2one('res.bank','Cuenta Bancaria',required=True                                          ,
                          states={'draft':[('readonly',False)]    , 
                                  'received':[('readonly',True)]  ,        
                                  'send':[('readonly',True)]})    ,
    'bank_id':fields.related('accounting_bank_id','bank_id',type='many2one',relation='res.bank.entity',string='Banco',store=True,readonly=True,help='El nombre de la Entidad Bancaria se carga automaticamente al guardar')                                                          ,
    'agen_id':fields.related('accounting_bank_id', 'agencia',type='char', size=30, string='Agecia Bancaria', store=True, readonly=True, help='El nombre de la Agencia Bancaria se carga automaticamente al guardar')  ,
    'partner_id': fields.many2one('res.partner', 'Autorizado',required=True,
                   states={'draft':[('readonly',False)]    , 
                           'received':[('readonly',True)]  ,       
                           'send':[('readonly',True)]})    ,
    'check_book_ids': fields.one2many('check.book', 'check_book_request_id', 'Chequeras',required=True,
                      states={'draft':[('readonly',False)]    , 
                              'received':[('readonly',True)]  ,       
                              'send':[('readonly',True)]})    , 
    'state': fields.selection([
            ('draft','Draft')         ,
            ('send','Enviar')         ,
            ('received','Recibido')   ,   
            ('cancel','Cancel')       ,
            ],'Estado', select=True, readonly=True, help="Estado de la Solicitud de la Chequera")                            ,
    }
    _rec_name='code' # esto es para no crear un atributo name
    _defaults = {
        'state': lambda *a: 'draft'                                                                                          ,
        'code': lambda obj, cr, uid, context: obj.pool.get('ir.sequence').get(cr, uid, 'check.book.request')                 ,     
    }
    

    #cambia el estado del documento y se muestra el rml para impresion  
    def get_enviar(self, cr, uid, ids, context={}):
        book_request = self.browse(cr,uid,ids)
        for request in book_request:
            self.write(cr,uid,request.id,{'state' : 'send'})
            
    #se cancelan las chequeras asociadas a la solicitud
    def get_anular(self, cr, uid, ids, context={}):
        book_request = self.browse(cr,uid,ids)
        for request in book_request:
            self.write(cr,uid,request.id,{'state' : 'cancel'})
            for book in request.check_book_ids: #por cada chequera
                self.pool.get('check.book').write(cr,uid,book.id,{ 'state' : 'cancel',
                                                                   'date_done' : time.strftime('%Y-%m-%d'),
                                                                   'notes' : 'Cancelacion de Chequera por Solicitud' })      

    #cambia el estado del documento a received, el estado draft en chequera y fecha de recepcion
    def get_received(self, cr, uid, ids, context={}):
        book_request = self.browse(cr,uid,ids)
        for request in book_request:
            self.write(cr,uid,request.id,{'state' : 'received'}) 
            for c in request.check_book_ids: #para las chequeras
                self.pool.get('check.book').write(cr,uid,c.id,{'state' : 'draft', 'date_draft':time.strftime('%Y-%m-%d') }) 

    def onchange_accounting_bank_id(self, cr, uid, ids, accounting_bank_id): 
        #result={}   
        boock = self.pool.get('check.book').search(cr, uid, [('accounting_bank_id','=',accounting_bank_id) , 
                                                              ('state', '=', 'request')                    , 
                                                              ('check_book_request_id', '=', False)]) 
        result = {'value': {'check_book_ids': boock} }
        return result 
    
check_book_request()
