# -*- encoding: utf-8 -*-
###########################################################################
#    Module Writen to OpenERP, Open Source Management Solution
#    Copyright (C) OpenERP Venezuela (<http://openerp.com.ve>).
#    All Rights Reserved
###############Credits######################################################
#    Coded by: Angelica Barrios angelicaisabelb@gmail.com
#              Humberto Arocha humberto@openerp.com.ve
#    Planified by: Humberto Arocha
#    Finance by: LUBCAN COL S.A.S http://www.lubcancol.com
#    Audited by: Humberto Arocha humberto@openerp.com.ve
#############################################################################
#    This program is free software: you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation, either version 3 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program.  If not, see <http://www.gnu.org/licenses/>.
##############################################################################


import time
from report import report_sxw
from osv import osv
import pooler
import datetime
from mx.DateTime import *


class rep_conteo_stock_general(report_sxw.rml_parse):
    def __init__(self, cr, uid, name, context):
        super(rep_conteo_stock_general, self).__init__(cr, uid, name, context)    
        self.localcontext.update({
            'time': time                         ,
            'get_data':self.get_data             ,
            'get_encabezado':self.get_encabezado ,
            'get_lineas': self.get_lineas        ,
            'get_cantidad':self.get_cantidad     ,
            'ex_inicial':self.ex_inicial         ,
            'ex_final':self.ex_final             ,
            'origen_dest':self.origen_dest        ,
        })


    
    def get_encabezado(self, stock=None):
        product= self.pool.get('product.template')
        cate= self.pool.get('product.category')
        cabeza=[]
        if stock.almacenable_consumible==True:
            cabeza.append("Almacenable/Consumible")
        else:
            cabeza.append(" ")   
        if stock.servicio==True:
            cabeza.append("Servicio")
        else:
            cabeza.append(" ") 
        if not stock.almacenable_consumible==True and not stock.servicio==True:
            cabeza[0]="Almacenable/Consumible"
            cabeza[1]="Servicio"
       
    
        if stock.categoria:
            cabeza.append(" %s"%(stock.categoria.name))
        else:
            cabeza.append("Todas las Categorias") 
       
        if stock.estado:
            cabeza.append(" %s"%(stock.estado))
        else:
            cabeza.append("Todas los Estados")
        
        if stock.vendible:
            cabeza.append("Vendible")
        else:
            cabeza.append(" ")
        if stock.comprable:
            cabeza.append("Comprable")
        else:
            cabeza.append(" ")
        if stock.alquilable:
            cabeza.append("Alquilable")
        else:
            cabeza.append(" ")
        if not stock.vendible and not stock.comprable and not stock.alquilable:
            cabeza[4]="Vendible"
            cabeza[5]="Comprable"
            cabeza[6]="Alquilable" 
              
       # print cabeza
        
        return cabeza
    
    
    def get_data (self,stock=None ):
        print"Entro al metodo get_data"
#        print "el estado es: ",stock.estado
        product= self.pool.get('product.template')
        
        ##################para el tipo del producto####################
        tipo=[]
        if stock.almacenable_consumible==True:
            stock_pro = product.search(self.cr, self.uid, [('type', '=',"product")])
            tipo.extend(stock_pro)

        if stock.servicio==True:
            stock_serv = product.search(self.cr, self.uid, ['|',('type', '=',"consut"),('type', '=',"service")]) 
            tipo.extend(stock_serv)

        #sin repetisiones obtengo los tipos de productos
        sin_repetir_tipo=[x for x in set(tipo)]
        
        if not sin_repetir_tipo: #si esta vacia
            sin_repetir_tipo=product.search(self.cr, self.uid, [])
        
#        print "sin_repetir_tipo: ",sin_repetir_tipo 
        
        ##################para la categoria####################
        stock_category=[]
        if stock.categoria:
            stock_category = product.search(self.cr, self.uid, [('categ_id', '=',stock.categoria.id)])

        else: #dame todos
            stock_category = product.search(self.cr, self.uid, [])
        if not stock_category:
            stock_category = product.search(self.cr, self.uid, [])
            
#        print "stock_category: ",stock_category
            
            
            
        ##################para el estado####################
        stock_estado=[]
        if stock.estado:
            if stock.estado=="desarrollo":
                stock_estado = product.search(self.cr, self.uid, [('state', '=',"draft")])
                
            if stock.estado=="produccion":
                stock_estado = product.search(self.cr, self.uid, [('state', '=',"sellable")])

            if stock.estado=="fin":
                stock_estado = product.search(self.cr, self.uid, [('state', '=',"end")])

            if stock.estado=="obsoleto":
                stock_estado = product.search(self.cr, self.uid, [('state', '=',"obsolete")])
  
            if stock.estado=="none":
                stock_estado = product.search(self.cr, self.uid, [('state', '=',None)])

        else:
            stock_estado = product.search(self.cr, self.uid, [])
        if not stock_estado:
            stock_estado = product.search(self.cr, self.uid, [])
        
#        print "stock_estado: ",stock_estado
            
                
        ##################destinado a ser: vendible, conyable, alquilable####################
        destino=[]
        if stock.vendible:
            stock_ven=product.search(self.cr, self.uid, [('sale_ok', '=',True)])
            destino.extend(stock_ven)

        if stock.comprable:
            stock_comp=product.search(self.cr, self.uid, [('purchase_ok', '=',True)])
            destino.extend(stock_comp)

        if stock.alquilable:
            stock_alq=product.search(self.cr, self.uid, [('rental', '=',True)])
            destino.extend(stock_alq)
        #sin repetisiones obtengo los tipos de productos
        sin_repetir_destino=[x for x in set(destino)] 
        if not sin_repetir_destino:
            sin_repetir_destino=product.search(self.cr, self.uid, [])  
#        print "sin_repetir_destino: ",sin_repetir_destino
        
#se une todas las intersecciones de los filtros para los productos
        ids_product_template=list(set(sin_repetir_tipo)&set(stock_category)&set(stock_estado)&set(sin_repetir_destino))
#        print "TOTALLLLLLLLL:",ids_product_template
        
        data =product.browse(self.cr,self.uid, ids_product_template)
        
        return data


    #metodo que devuelve las lineas
    def get_lineas(self,product_template=None,stock=None ):
        lista=[]
        print "el id de product_template es: ",product_template.id
        print"Entro al metodo get_lineas"

        ca= self.pool.get('stock.picking')
        cabeza = ca.search(self.cr, self.uid, [('date_done' , '>=', stock.fecha_inicio)     ,
                                               ('date_done', '<=' , stock.fecha_fin )       ,
                                               ('state','=','done')                         ,       
                                               ])
        #print "la cabezas que hay en el rango de fecha es: ", cabeza
        linea= self.pool.get('stock.move')
        li=linea.search(self.cr, self.uid, [('product_id', '=',product_template.id)])
        lineas=linea.browse(self.cr, self.uid, li)
        #print "lineas que tienen el producto",lineas
        for line in lineas:
            if line.picking_id.id in cabeza:
                lista.append(line)
                
        print "la lista que corresponde al producto para la fecha es: ", lista    
        return lista


    def get_cantidad(self,product_template=None):
        product= self.pool.get('product.product')
        pro=product.browse(self.cr, self.uid, product_template.id)   
        cantidad=pro.qty_available
        return cantidad


    def ex_inicial(self,product_template=None,stock=None):
        print"metodo que calcula la existencia inicial"
        a=time.strftime('%m/%d/%Y')
        print "a es: ", a
        ano=a[6:10]
        print "el ano es: ", ano
        start = DateTime(int(ano),1,1).strftime('%m/%d/%Y') #primero de enero del ano en curso

        ca= self.pool.get('stock.picking')
        cabeza = ca.search(self.cr, self.uid, [('date_done' , '>=', start )                   ,
                                               ('date_done', '<' , stock.fecha_inicio )       ,
                                               ('state','=','done')                           ,       
                                               ])
        linea= self.pool.get('stock.move')
        li=linea.search(self.cr, self.uid, [('product_id', '=',product_template.id)])
        lineas=linea.browse(self.cr, self.uid, li)
        linea_destino=0.0
        linea_origen=0.0
        for line in lineas:
            if line.picking_id.id in cabeza:
                if line.location_id.name=="Stock":  #origen
                    linea_origen+=line.product_id.qty_available
                if line.location_dest_id.name=="Stock":  #destino
                    linea_destino+=line.product_id.qty_available
        print "las lineas origen es:", linea_origen
        print "las lineas destino es:", linea_destino
        inicial=abs(linea_origen-linea_destino)

        return inicial



    def ex_final(self,product_template=None,stock=None):
        print"metodo que calcula la existencia final"
   
        ca= self.pool.get('stock.picking')
        cabeza = ca.search(self.cr, self.uid, [('date_done' , '>=', stock.fecha_inicio)     ,
                                               ('date_done', '<=' , stock.fecha_fin )       ,
                                               ('state','=','done')                         ,       
                                               ])
        linea= self.pool.get('stock.move')
        li=linea.search(self.cr, self.uid, [('product_id', '=',product_template.id)])
        lineas=linea.browse(self.cr, self.uid, li)
        linea_destino=0.0
        linea_origen=0.0
        for line in lineas:
            if line.picking_id.id in cabeza:
                if line.location_id.name=="Stock":  #origen
                    linea_origen+=line.product_id.qty_available
                if line.location_dest_id.name=="Stock":  #destino
                    linea_destino+=line.product_id.qty_available
        print "las lineas origen es:", linea_origen
        print "las lineas destino es:", linea_destino
        final=abs(linea_origen-linea_destino)

        return final


    def origen_dest(self, tipo):
        lugar="-"
        if tipo=="Customers":
            lugar="Cliente"
        if tipo=="Suppliers":
            lugar="Proveedor"
        if tipo=="Stock":
            lugar="Stock"
        if tipo=="Output":
            lugar="Salida"
        return lugar
      
report_sxw.report_sxw(
    'report.informe.detallado.inventario'                      ,  
    'stock.count.general'                                      ,
    'addons/l10n_co_general_stock/report/stock_detallado.rml'  ,  
    parser=rep_conteo_stock_general                                    ,
)      
