# -*- encoding: utf-8 -*-
###########################################################################
#    Module Writen to OpenERP, Open Source Management Solution
#    Copyright (C) OpenERP Venezuela (<http://openerp.com.ve>).
#    All Rights Reserved
###############Credits######################################################
#    Coded by: Angelica Barrios angelicaisabelb@gmail.com
#              Humberto Arocha humberto@openerp.com.ve
#    Planified by: Humberto Arocha
#    Finance by: LUBCAN COL S.A.S http://www.lubcancol.com
#    Audited by: Humberto Arocha humberto@openerp.com.ve
#############################################################################
#    This program is free software: you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation, either version 3 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program.  If not, see <http://www.gnu.org/licenses/>.
##############################################################################
from osv import osv
from osv import fields
from tools.translate import _
from tools import config
import time

class purchase_order_line(osv.osv):
    _inherit = 'purchase.order.line'
    _columns = {
        'concept_retention_ica': fields.many2one('baremo.ciiu.item','Concepto de ReteIca'), 
    }

    def product_id_change(self, cr, uid, ids, pricelist, product, qty, uom, partner_id, date_order=False, fiscal_position=False):
        data = super(purchase_order_line, self).product_id_change(cr, uid, ids, pricelist, product, qty, uom,partner_id, date_order, fiscal_position)
        print "entro en el onchange del producto de la linea de la orden de compra"
        if not product:
            return {'value': {'price_unit': 0.0, 'name':'','notes':'', 'product_uom' : False}, 'domain':{'product_uom':[]}}  
        pro = self.pool.get('product.product').browse(cr, uid, product)
        concepto=pro.ciiu_id.id
        data[data.keys()[1]]['concept_retention_ica'] = concepto
        return data

purchase_order_line()



class purchase_order(osv.osv):
    _inherit = 'purchase.order'
    #metodo que sobreescribe al original, agrega en las lineas de la factura el concepto de retencion, 
    #este es llamado por action_invoice_create, que crea la factura
    def inv_line_create(self, cr, uid, a, ol):
        data = super(purchase_order, self).inv_line_create(cr, uid, a, ol)
        data[2]['concept_retention_ica'] = ol.concept_retention_ica.id #se le agrega a la lista para insertar el concepto de retencion
        return data
     
purchase_order()






