# -*- encoding: utf-8 -*-
###########################################################################
#    Module Writen to OpenERP, Open Source Management Solution
#    Copyright (C) OpenERP Venezuela (<http://openerp.com.ve>).
#    All Rights Reserved
###############Credits######################################################
#    Coded by: Angelica Barrios angelicaisabelb@gmail.com
#              Humberto Arocha humberto@openerp.com.ve
#    Planified by: Humberto Arocha
#    Finance by: LUBCAN COL S.A.S http://www.lubcancol.com
#    Audited by: Humberto Arocha humberto@openerp.com.ve
#############################################################################
#    This program is free software: you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation, either version 3 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program.  If not, see <http://www.gnu.org/licenses/>.
##############################################################################

import time
from report import report_sxw
from osv import osv
import pooler

class rep_comprobante_ica_anual_wizard(report_sxw.rml_parse):

    def __init__(self, cr, uid, name, context):
        super(rep_comprobante_ica_anual_wizard, self).__init__(cr, uid, name, context)    
        self.localcontext.update({
            'time': time,
            'get_data':self._get_data           ,
            'get_dates':self._get_dates         ,
            'get_fecha_emi':self._get_fecha_emi ,
            'get_tipo':self._get_tipo           ,
        })
        
        
    def _get_data(self,form):
        periodo=form['fiscalyear_id']
        fiscalyear = self.pool.get('account.fiscalyear')
        year=fiscalyear.browse(self.cr, self.uid, periodo)
        reporte=self.pool.get('reporte.anual.ica')
        rete_ica=self.pool.get('account.retention.ica')
        print "el periodo fiscal es:", year.name
        bandera=0   
        vector=[]
        linea=[]
        data=[]        
        for i in year.period_ids: #para todos los periodos
            print "el periodo es: ", i.name
            ica = rete_ica.search(self.cr, self.uid, [('period_id', '=',i.id)])
            if len(ica)!=0: #si esta en un periodo
                print ica
                vector=ica
                bandera=1 
        if bandera==1: #si hay periodo asociados a ese ano en el modelo de retencion, si no entra aqui se manda una excepcion
            data = rete_ica.browse(self.cr,self.uid, vector)   
        
        return data
    
    
    def _get_dates(self, form):
        res=[]
        periodo=form['fiscalyear_id']
        fiscalyear = self.pool.get('account.fiscalyear')
        year=fiscalyear.browse(self.cr, self.uid, periodo)
        ano=year.name
        res.append(ano)
        res.append("hola")
        return ano

    def _get_fecha_emi(self,form):
        res=[]
        res.append(time.strftime('%Y-%m-%d') )     
        return res

    
    def _get_tipo(self, vat=''):
        print vat
        if vat == 'in_invoice' or vat == 'in_refund':
            res="Compra"
        elif vat == 'out_invoice' or vat == 'out_refund':
            res="Venta"  
        if not vat:
            res=""
        return res


report_sxw.report_sxw(
    'report.comprobante.retencion.ica.anual_wizard'                ,
    'reporte.anual.ica'                                            ,
    'addons/l10n_co_ica/report/comprobante_ica_anual_wizard.rml'   ,
    parser=rep_comprobante_ica_anual_wizard                        ,
)      
