# -*- encoding: utf-8 -*-
###########################################################################
#    Module Writen to OpenERP, Open Source Management Solution
#    Copyright (C) OpenERP Venezuela (<http://openerp.com.ve>).
#    All Rights Reserved
###############Credits######################################################
#    Coded by: Angelica Barrios angelicaisabelb@gmail.com
#              Humberto Arocha humberto@openerp.com.ve
#    Planified by: Humberto Arocha
#    Finance by: LUBCAN COL S.A.S http://www.lubcancol.com
#    Audited by: Humberto Arocha humberto@openerp.com.ve
#############################################################################
#    This program is free software: you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation, either version 3 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program.  If not, see <http://www.gnu.org/licenses/>.
##############################################################################

from osv import osv
from osv import fields
from tools.translate import _
from tools import config



REGIMEN_ICA = [('Ent_Publi', 'Entidades Publicas')                              ,
               ('Gran_Contrib', 'Gran Contribuyente')                           ,
               ('Consorcios_Un_Temp', 'Consorcios y Uniones Temporales')        ,
               ('Cont_Reg_Com', 'Contribuyentes Regimen Comun')                 ,
               ('Transport' , 'Transportadores')                                ,
               ('Cont_Reg_Simpli', 'Contribuyentes Regimen Simplificado')       ,
               ('Profesores_Indep', 'Profesionales Independientes Regimen Comun')  ,
            ]

class tax_payer_ica(osv.osv):
    _name='tax.payer.ica'
    _columns={
    'name': fields.char('Tipos de Contributentes para ICA',size=64, required=False, readonly=False)          ,
    'notes': fields.text('Notas', required=False, readonly=False)                                            ,
    'retenido_ids': fields.one2many('tax.payer.ica.supplier', 'type', 'Hijos')                               ,
    'retenerdor_ids': fields.one2many('tax.payer.ica.customer', 'type', 'Hijos')                             ,
    'iva':fields.selection(REGIMEN_ICA, 'Tipo de Contribuyente')                                             ,
    'partner_ids': fields.one2many('res.partner', 'type_ica', 'Hijos')                                       ,
    }
  
  
  
    def name_uniq(self,cr,uid,ids,context={}):
        obj_ica = self.browse(cr,uid,ids[0])
        cr.execute('select a.name  from tax_payer_ica a')
        lista=cr.fetchall()
        print lista
        #comprension de lista
        bandera=([x[0] for x in lista if x[0] == obj_ica.name])
        #bandera devuelve una lista de las ocurrencias
        print"bandera es:", bandera
        if  len(bandera)>1 :
            return False
        return True  
    
    _constraints = [
        (name_uniq, 'Error ! Este Contribuyente ya existe. ', ['name'])
    ]  
    
    def create(self, cr, user, vals, context=None):
        """
        Update redord(s) comes in {ids}, with new value comes as {vals}
        return True on success, False otherwise   
        @param cr: cursor to database
        @param user: id of current user
        @param ids: list of record ids to be update
        @param vals: dict of new values to be set
        @param context: context arguments, like lang, time zone 
        @return: True on success, False otherwise
        """
        print "paso por el create"
        for reg in REGIMEN_ICA:
            if reg[0] == vals['iva']:
                vals_ica = reg[1]
                break
                
        vals['name']="%s" % (vals_ica)
        return super(tax_payer_ica, self).create(cr, user, vals, context)

    def write(self, cr, user,ids, vals, context=None):
        """
        Update redord(s) comes in {ids}, with new value comes as {vals}
        return True on success, False otherwise   
        @param cr: cursor to database
        @param user: id of current user
        @param ids: list of record ids to be update
        @param vals: dict of new values to be set
        @param context: context arguments, like lang, time zone 
        @return: True on success, False otherwise
        """
        print "paso por el write"
        for reg in REGIMEN_ICA:
            if reg[0] == vals['iva']:
                vals_ica = reg[1]
                break
                
        vals['name']="%s " % (vals_ica)
        return super(tax_payer_ica, self).write(cr, user, ids, vals, context)
  
  
 
    
tax_payer_ica()





