# -*- encoding: utf-8 -*-
###########################################################################
#    Module Writen to OpenERP, Open Source Management Solution
#    Copyright (C) OpenERP Venezuela (<http://openerp.com.ve>).
#    All Rights Reserved
###############Credits######################################################
#    Coded by: Angelica Barrios angelicaisabelb@gmail.com
#              Humberto Arocha humberto@openerp.com.ve
#    Planified by: Humberto Arocha
#    Finance by: LUBCAN COL S.A.S http://www.lubcancol.com
#    Audited by: Humberto Arocha humberto@openerp.com.ve
#############################################################################
#    This program is free software: you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation, either version 3 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program.  If not, see <http://www.gnu.org/licenses/>.
##############################################################################
from osv import osv
from osv import fields
from tools.translate import _
from tools import config
import time

################################################RETENCION ICA################################################
class account_invoice(osv.osv):
    _inherit = 'account.invoice'
    _columns = {

        'procesado_ica': fields.selection([
            ('pro','Procesado')                   ,
            ('no_pro','No Procesado')             ,
            ],'Estatus', readonly=True )          ,
        'rete_ica_doc': fields.many2one('account.retention.ica', 'Documento de Retencion ICA', readonly=True)     , 
        'status_ica': fields.selection([
            ('no_cal','Retencion no Calculada')                             ,
            ('cal','Retencion Calculada')                                   ,
            ('tax_payer','No se aplica retencion entre los Contribuyentes') ,
            ('tasa','No supera la tasa')                                    ,
            ],'status',readonly=True )                                      ,
    }
    
    _defaults = {
        'procesado_ica': lambda *a: "no_pro",
        'status_ica': lambda *a: "no_cal",
    }
    
    
    def copy(self, cr, uid, id, default=None, context=None):
        if default is None:
            default = {}
        default = default.copy()
        default.update({'rete_iva_doc':None , 'procesado':'no_pro'      , 'status_rete':'no_cal',   
                        'rete_ica_doc':None , 'procesado_ica':'no_pro'  , 'status_iva':'no_cal' ,
                        'rete_rete_doc':None, 'procesado_rete':'no_pro' , 'status_ica':'no_cal' ,
                         })
        return super(account_invoice, self).copy(cr, uid, id, default, context)
    
    
    # Metodo que verifica si se retiene impuesto para ICA segun la tabla de contribuyentes y
    #verifica que se encuentre en la tabla de contribuyentes 
    def _validar_Contribuyente_ica(self, cr, uid, ids, context=None):
        res = {}
        print "se evalua si se aplica retencion de ICA"
        invoices = self.browse(cr, uid, ids, context=None) # toma los objetos de tipo invoice para recorrerlos dentro de un for
        procesado=True
        for inv in invoices:
            if inv.procesado_ica=="no_pro": #si aun no se ha procesado la orden de retencion para ica
                procesado=False
                if inv.type == 'in_invoice' or inv.type == 'in_refund': #si se trata de una factura de COMPRA
                    #~ si estoy aqui dentro es porque soy un comprador,
                    id_factura=inv.id #inv.id es el id de la cabecera de la factura
                    print "Se trata de una factura de Compra"
                    comprador_ica =inv.company_id.partner_id.type_ica.id 
                    vendedor_ica = inv.partner_id.type_ica.id
                    descrip_vendedor_ica= inv.partner_id.ciiu_id.name 
                    codigo_vendedor_ica=  inv.partner_id.ciiu_id.codigo
                    direccion_comprador_ica=inv.company_id.partner_id.address #direccion del partner (puede tener muchas direcciones)
                    id_partner_vendedor=inv.partner_id.id
                    print "el comprador para ica es:"
                    print inv.company_id.partner_id.type_ica.name 
                    print "el vendedor para ica es:"
                    print inv.partner_id.type_ica.name

                    
                elif inv.type == 'out_invoice' or inv.type == 'out_refund': #si se trata de una factura de VENTA
                    #~ si estoy aqui dentro es porque soy un vendedor,
                    id_factura=inv.id #inv.id es el id de la cabecera de la factura
                    print "Se trata de una factura de Venta"
                    comprador_ica = inv.partner_id.type_ica.id 
                    vendedor_ica = inv.company_id.partner_id.type_ica.id
                    descrip_vendedor_ica= inv.company_id.partner_id.ciiu_id.name  
                    codigo_vendedor_ica=  inv.company_id.partner_id.ciiu_id.codigo          
                    direccion_comprador_ica=inv.partner_id.address #direccion del partner
                    id_partner_vendedor=inv.company_id.partner_id.id
                    print "el comprador para ica es:"
                    print inv.partner_id.type_ica.name
                    print "el vendedor para ica es:"
                    print inv.company_id.partner_id.type_ica.name
        
        
        #despues se verifica que tanto comprador como vendedor existan 
        if procesado==False: #solo sigue con las verificaciones si no esta procesado
 
            if vendedor_ica== False:
                raise osv.except_osv(_('Atencion !'), _('Debe establecer el tipo de Contribuyente ICA en la Pestaña de Contribuyentes para el Vendedor !!!'))           
            if comprador_ica== False:
                raise osv.except_osv(_('Atencion !'), _('Debe establecer el tipo de Contribuyente ICA en la Pestaña de Contribuyentes para el Comprador !!!'))
            
            #se verifica el baremo de ICA
            
            tabla_contribuyente_ica = self.pool.get('tax.payer.ica.supplier')   
            t_ids_ica = tabla_contribuyente_ica.search(cr, uid, [('type','=',vendedor_ica)], limit = 1)      
            tipo_de_vendedor_ica = tabla_contribuyente_ica.browse(cr, uid, t_ids_ica, context=None)    
            vendedor_vale_ica = False
            comprador_vale_ica = False      
            for cada_vendedor_ica in tipo_de_vendedor_ica:
                if cada_vendedor_ica.type.id == vendedor_ica:
                    #~ si estoy aqui es porque este es el tipo de vendedor
                    vendedor_vale_ica = True
                    for cada_comprador_ica in cada_vendedor_ica.retenedor_ids:
                        if cada_comprador_ica.type.id == comprador_ica:
                            comprador_vale_ica = True
                            #~ si estoy aqui es porque este es el tipo de comprador
                            res['aplica_ica'] = cada_comprador_ica.bool_ica
                            print "la retencion que aplica para ica es:"
                            print cada_comprador_ica.bool_ica
                    break # cortamos aqui el primer ciclo porque ya hemos obtenido lo que deseabamos
                
            contribuyente_ica = self.pool.get('tax.payer.ica') 
            if vendedor_vale_ica== False:
                raise osv.except_osv(_('Atencion !'), _('El tipo de Contribuyente del Vendedor [%s] \n no esta registrado en la Tabla de Contribuyentes de ICA, \n Vaya a la Tabla de Contribuyentes de ICA y registre dicho Tipo !!!')%(contribuyente_ica.browse(cr, uid, vendedor_ica).name))
            if comprador_vale_ica== False:
                raise osv.except_osv(_('Atencion !'), _('El tipo de Contribuyente del Comprador [%s] \n no esta registrado en la Tabla de Contribuyentes de ICA, \n para el tipo de Vendedor [%s] de esta Factura \n Vaya a la Tabla de Contribuyentes ICA y registre dicho Tipo !!!')%(contribuyente_ica.browse(cr, uid, comprador_ica).name,contribuyente_ica.browse(cr, uid, vendedor_ica).name))
            
            if procesado==True: #si esta procesado_ica
                raise osv.except_osv(_('Atencion !'), _('Ya esta procesado la solicitud de retencion ICA para esta factura'))    

            #se verifican todas las validaciones para procesar la solicitud de retencion para ica
            #ciudad, productos, actividad
            if res['aplica_ica'] == True:
                bandera=self._verif_ciudad_activ(direccion_comprador_ica, codigo_vendedor_ica, vendedor_ica, comprador_ica , cr, uid, ids)
                if bandera==1: #si existe una ciudad y una actividad asignado tanto en el baremo ica como en los partner
                    if self. _verificar_cuenta_ciiu(id_partner_vendedor, cr, uid, ids):
                        self._retener_ica(direccion_comprador_ica,descrip_vendedor_ica,codigo_vendedor_ica, vendedor_ica, comprador_ica,id_factura,id_partner_vendedor, cr, uid, ids) 
            else: #si no aplica retencion
                inv.write({'status_ica':"tax_payer" })             
           
        if procesado==True:
            raise osv.except_osv(_('Atencion !'), _('Ya se realizo retencion de ICA para esta factura'))   
        return True



    #Metodo que verifica que el retenedor(comprador) tiene asignada una ciudad y que el 
    #retenido(vendedor) tiene asignada una actididad en el baremo_ciiu_item, todo esto es para
    #calcular la retencion para ICA
    def _verif_ciudad_activ(self, direccion_comprador_ica, codigo_vendedor_ica , vendedor_ica, comprador_ica, cr, uid, ids, context=None):
        bandera=0 #false
        bandera2=0#false
        print "metodo de verificacion de la ciudad y la actividad "
        for ciudad in direccion_comprador_ica:                 
            if ciudad.city_id : #si existe alguna ciudad asociado
                print "la ciudad del comprador es: ", ciudad.city_id.name 
                bandera=1
                
        if bandera ==0:#porque el partner no tiene asociado ninguna ciudad ni direccion
            raise osv.except_osv(_('Atencion !'), _('Debe de Ingresar la Ciudad que pertenece el partner !!!'))
          
        print "el codigo del partner vendedor de ICA en baremo_ciiu_iten es:"
        print codigo_vendedor_ica
        if codigo_vendedor_ica==False:
            bandera=0
            raise osv.except_osv(_('Atencion !'), _('Debe de Ingresar la Actividad para la Retención Municipal \n  en la pestaña de Retencion ICA para el partner !!!'))
        # se verifica la ciudad del comprador sea la misma que la del baremo    
        contribuyente_ica = self.pool.get('tax.payer.ica')
        partner=contribuyente_ica.browse(cr, uid, vendedor_ica).partner_ids

        for part in partner:
            ciiu=part.ciiu_id.codigo
            if ciiu==codigo_vendedor_ica:
                tarifa=part.ciiu_id.tarifas_ids #tarifa del vendedor
                for tar in tarifa:#ya que pueden ser muchas tarifas y ciudades asociados a ella
                    ciudad=tar.id_ciudad.name
                    for est in direccion_comprador_ica:
                        if est.city_id.name == ciudad:    #ciudad del comprador
                            bandera2=1              
        if bandera2==0:
            raise osv.except_osv(_('Atencion !'), _('Debe de Ingresar la Ciudad, en la Actividad del menu Baremo ICA'))
        print "la bandera es:", bandera          
        return bandera


    #metodo que verifica que exista las cuentas de compra y de venta en el baremo ciiu
    def _verificar_cuenta_ciiu(self,id_partner_vendedor, cr, uid, ids, context=None):
        print "Entro en el metodo que verifica que exista la cuenta del ciiu"
        pa = self.pool.get('res.partner')
        partener_vendedor= pa.browse(cr, uid, id_partner_vendedor, context=None)
        if partener_vendedor.ciiu_id.retencion_compra and partener_vendedor.ciiu_id.retencion_venta:
            return True
        else:
            raise osv.except_osv(_('Atencion !'), _('Debe de Ingresar la Cuenta de Compra y/o Venta en la Actividade de Industria y Comercio'))
            bandera=0
            return False 



    #Metodo que calcula la tarifa para la retencion del ICA de acuerdo a la ciudad y a la actividad
    def _retener_ica(self,direccion_comprador_ica,descrip_vendedor_ica,codigo_vendedor_ica, vendedor_ica, comprador_ica,id_factura,id_partner_vendedor, cr, uid, ids, context=None): 
        print "siguiente paso de retencion ica"
        inv = self.browse(cr, uid, id_factura, context=None)
        contribuyente_ica = self.pool.get('tax.payer.ica')
        pa = self.pool.get('res.partner')
        partener_vendedor= pa.browse(cr, uid, id_partner_vendedor, context=None)
        cuenta={}
        cuenta['compra']=partener_vendedor.ciiu_id.retencion_compra
        cuenta['venta']= partener_vendedor.ciiu_id.retencion_venta
        
        partner=contribuyente_ica.browse(cr, uid, vendedor_ica).partner_ids
        ciiu_item = self.pool.get('baremo.ciiu.item')
        tarifa_partner=0
        
        for part in partner: #para todos los partner que sea de ese tipo de contribuyente vendedor ica
            ciiu=part.ciiu_id.codigo
            if ciiu==codigo_vendedor_ica:  #filtro del codigo en el baremo_ica del partener
                tari=part.ciiu_id.tarifas_ids #tarifa del vendedor
                for tar in tari:
                    ciudad=tar.id_ciudad.name
                    for est in direccion_comprador_ica: 
                        if est.city_id.name == ciudad:  #filtro de la ciudad del comprador
                            tarifa_partner=tar.tarifa #tarifa del partner  
        ################para las notas de credito################    
        if inv.type=="out_refund" or inv.type=="in_refund" :#para notas de credito
            if inv.parent_id and inv.parent_id.procesado_ica=="pro" : #si tiene factura padre y tiene retencion   
                maximo=self.calculoTarifa(cr, uid, ids, inv.id, tarifa_partner, ciudad, context=None)
                retention_id=self.crear_retencion_ica(cr, uid, ids, inv.id) #inv.id es el id de la cabecera de la factura
                self.crear_retencion_ica_line_refund( cr, uid, ids, inv.id, retention_id,maximo, ciudad,descrip_vendedor_ica, cuenta, context=None)
                inv.write({'procesado_ica':"pro",'rete_ica_doc':retention_id , 'status_ica':"cal"})  
            else:
                raise osv.except_osv(_('Atencion !'), _('La Nota de Credito no tiene factura asociada o aun esta no ha sido \n retenida, no podra retener!!!')) 
        ##########################################################
        else: #para las facturas
            maximo=self.calculoTarifa(cr, uid, ids, inv.id, tarifa_partner, ciudad, context=None)
            if maximo!=0:
                #ENCABEZADO DE LA RETENCION
                retention_id=self.crear_retencion_ica(cr, uid, ids, inv.id) #inv.id es el id de la cabecera de la factura
                #LINEAS DE LA RETENCION
                self.crear_retencion_ica_line( cr, uid, ids, inv.id, retention_id,maximo, ciudad,descrip_vendedor_ica, cuenta, context=None)
                inv.write({'procesado_ica':"pro",'rete_ica_doc':retention_id , 'status_ica':"cal"}) 
            else:
                inv.write({'status_ica':"tasa" })                                               
        return True  


    #Metodo que crea la cabecera del documento de retencion para ICA  
    def crear_retencion_ica(self, cr, uid, ids, inv_id, context=None):
        print "entra al metodo de retencion ica"
        rete_ica=self.pool.get('account.retention.ica')
        codigo=rete_ica._get_seq_code(cr, uid, context=None) #se llama al metodo para obtener el numero de secuencia del CODE
        inv = self.browse(cr, uid, inv_id, context=None)
        if inv.type == 'in_invoice' or inv.type == 'in_refund': #si es una factura de compra
            if not inv.reference:
                referencia="-"
            else:
                referencia=inv.reference
            nombre="RETENCION DE ICA %s DEL DOCUMENTO %s CODIGO: %s" %(inv.partner_id.name ,referencia, codigo)
        else: #si es una factura de venta
            if not inv.number:
                number="-"
            else:
                number=inv.number
            nombre="RETENCION DE ICA %s DEL DOCUMENTO %s CODIGO: %s" %(inv.partner_id.name ,number, codigo)
            
        #ENCABEZADO DE RETENCIONES
        retention_id=rete_ica.create(cr, uid,{
                                'name':nombre                           ,
                                'period_id': None                       ,
                                'company_id': inv.company_id.id         ,
                               # 'code': None                           ,
                                'invoice_id': inv.id                    ,
                                'type':inv.type                         ,
                                'account_id':inv.account_id.id          ,
                                'partner_id':inv.partner_id.id          ,
                                'currency_id':inv.currency_id.id        ,
                                #'journal_id':inv.journal_id.id         ,#toma el defaul para el diario de ica 
                                'move_id':None                          ,
                                 #'state':"draft"                       ,# toma el defaul del modelo 
                                'date_ret':None                         ,
                                'date':time.strftime('%Y-%m-%d')        ,                                                             
                                },context=None)    
        return retention_id
 
 
 
    def calculoTarifa(self, cr, uid, ids, inv_id, tarifa_partner, ciudad, context=None):  
        inv = self.browse(cr, uid, inv_id, context=None)
        suma=0
        costo_producto=0
        costo_servicio=0
        tarifa_moneda_p=0
        tarifa_moneda_s=0
        bandera=0#false
        maximo=0
        productos=[]
        servicios=[]
        lista_tarifa_aplicar=[]
        lista_tarifa_aplicar.append(tarifa_partner)#se coloca la tarifa del partner en la lista de tarifas ciiu
        ret_iva_prod = False
        ret_iva_serv = False
        uvt = self.pool.get('l10n.co.uvt')
        iva_item = self.pool.get('iva.item')
        tarifa_prod = iva_item.search(cr, uid,[('producto','=','p'), ('date','<=', inv.date_invoice)], limit = 1, )
        tarifa_serv = iva_item.search(cr, uid,[('producto','=','s'), ('date','<=', inv.date_invoice)], limit = 1, )
          
        for line in inv.invoice_line:
            suma=suma+line.price_subtotal
            tipo_producto=line.concept_retention_iva
            if (tipo_producto=="p"):
                productos.append(line.id)
                print "esto es un producto"
                costo_producto+=line.price_subtotal       
            elif tipo_producto=="s":
                servicios.append(line.id)
                print "esto es un servicio"
                costo_servicio+=line.price_subtotal
            
        print "tarifa_prod", tarifa_prod,
        if len(tarifa_prod)==1 and costo_producto > 0:
            uvt_prod = iva_item.browse(cr, uid, tarifa_prod[0], context=None).tarifa
            print 'uvt_prod ', uvt_prod, '\n'
            tarifa_moneda_p = uvt.compute_uvt_to_money(cr, uid, uvt_prod, inv.date_invoice, context)#metodo que transforma los UVT en pesos
            print 'tarifa_moneda para productos ', tarifa_moneda_p, '\n'
            if costo_producto >= tarifa_moneda_p:
                ret_iva_prod = True
        elif len(tarifa_prod)==0 and costo_producto > 0:
            raise osv.except_osv(_('Atencion !'), _('No se ha estipulado una Tasa de IVA sobre Productos con Vigencia para la Fecha: %s, \ndirijase a Baremo IVA') %(inv.date_invoice))
            
        print "tarifa_serv", tarifa_serv,
        if len(tarifa_serv)==1 and costo_servicio > 0:
            uvt_serv = iva_item.browse(cr, uid, tarifa_serv[0], context=None).tarifa
            print 'uvt_serv ', uvt_serv, '\n'
            tarifa_moneda_s = uvt.compute_uvt_to_money(cr, uid, uvt_serv, inv.date_invoice, context)
            print 'tarifa_moneda ', tarifa_moneda_s, '\n'
            if costo_servicio >= tarifa_moneda_s:
                ret_iva_serv = True
        elif len(tarifa_serv)==0 and costo_servicio > 0:
            raise osv.except_osv(_('Atencion !'), _('No se ha estipulado una Tasa de IVA sobre Servicios con Vigencia para la Fecha: %s, \ndirijase a Baremo IVA') %(inv.date_invoice))


        if ret_iva_prod or ret_iva_serv:
            #se busca la tarifa a aplicar que es el max entre las ciiu de los productos y servicios y la ciiu del partner
            for line in inv.invoice_line:
                producto_tarifas=line.concept_retention_ica.tarifas_ids
                print "la tarifa del producto es: ", producto_tarifas
                bandera=0 
                if producto_tarifas:   
                    for tar in producto_tarifas:#ya que pueden ser muchas tarifas y ciudades asociados a ella
                        print "tar.id_ciudad.name: ", tar.id_ciudad.name
                        if ciudad == tar.id_ciudad.name:    #ciudad del comprador
                            lista_tarifa_aplicar.append(tar.tarifa) 
                            bandera=1#True
                    if bandera==0:#si no tiene el producto la ciudad del comprador
                        nota=''' El producto con concepto ReteIca codigo:[%i] %s no tiene estipulada la 
misma ciudad del comprador en el baremo de de Actividades de Industria y Comercio '''%(line.concept_retention_ica.codigo, line.concept_retention_ica.name)
                        raise osv.except_osv(_('Atencion !'), _(nota))
                else:
                    nota=''' El producto con concepto ReteIca codigo:[%i] %s no tiene estipulada la 
            tarifa en el baremo de de Actividades de Industria y Comercio '''%(line.concept_retention_ica.codigo, line.concept_retention_ica.name)
                    raise osv.except_osv(_('Atencion !'), _(nota))
                   
            #ahora se busca el maximo de la lista  
            print "la lista de ciiu es:", lista_tarifa_aplicar
            lista_tarifa_aplicar.sort() #ordena de menor a mayor la lista
            lista_tarifa_aplicar.reverse() #invierte el orden de los elementos de la lista
            maximo=lista_tarifa_aplicar[0] #el maximo esta en la posicion 0
            print "el maximo es:", maximo        
                    
        return maximo



    def crear_retencion_ica_line( self, cr, uid, ids, inv_id, retention_id, maximo, ciudad,descrip_vendedor_ica, cuenta, context=None):
        inv = self.browse(cr, uid, inv_id, context=None)
        suma=0
        for line in inv.invoice_line:
            suma+=line.price_subtotal*maximo/1000
                    
        if inv.type == 'in_invoice' or inv.type == 'in_refund': #si es una factura de compra
            tipo_cuenta=cuenta['compra']
        else: #si es una factura de venta
            tipo_cuenta=cuenta['venta']
                   
        rete_ica_line=self.pool.get('account.retention.ica.line')      
        rete_ica_line.create(cr, uid,{
            'name':descrip_vendedor_ica                  ,
            'retention_id':retention_id                  ,
            'move_line_id':None                          ,
            'tarifa':maximo                              ,
            'ciudad': ciudad                             ,
            'suma_total':suma                            ,
            'account_id': tipo_cuenta.id                 ,
                    },context=None)                                  
        return True

    def crear_retencion_ica_line_refund( self, cr, uid, ids, inv_id, retention_id, maximo, ciudad,descrip_vendedor_ica, cuenta, context=None):
        inv = self.browse(cr, uid, inv_id, context=None)
        suma=0
        for line in inv.invoice_line:
            suma+=line.price_subtotal*maximo/1000
                    
        if inv.type == 'in_invoice' or inv.type == 'in_refund': #si es una factura de compra
            tipo_cuenta=cuenta['compra']
        else: #si es una factura de venta
            tipo_cuenta=cuenta['venta']
                   
        rete_ica_line=self.pool.get('account.retention.ica.line')      
        rete_ica_line.create(cr, uid,{
            'name':descrip_vendedor_ica                  ,
            'retention_id':retention_id                  ,
            'move_line_id':None                          ,
            'tarifa':maximo                              ,
            'ciudad': ciudad                             ,
            'suma_total':-1*suma                         ,
            'account_id': tipo_cuenta.id                 ,
                    },context=None)                                  
        return True
    

account_invoice()
