# -*- encoding: utf-8 -*-
###########################################################################
#    Module Writen to OpenERP, Open Source Management Solution
#    Copyright (C) OpenERP Venezuela (<http://openerp.com.ve>).
#    All Rights Reserved
###############Credits######################################################
#    Coded by: Angelica Barrios angelicaisabelb@gmail.com
#              Humberto Arocha humberto@openerp.com.ve
#    Planified by: Humberto Arocha
#    Finance by: LUBCAN COL S.A.S http://www.lubcancol.com
#    Audited by: Humberto Arocha humberto@openerp.com.ve
#############################################################################
#    This program is free software: you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation, either version 3 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program.  If not, see <http://www.gnu.org/licenses/>.
##############################################################################

from osv import osv, fields

PRODUCTO =   [('p' , 'Producto')       ,
              ('s' , 'Servicio')       ,
             ]
        
class iva_item(osv.osv):
    """(NULL)"""    
    _name = 'iva.item'
    _order = 'date, name'
    _columns = {
        'name': fields.char('Clasificacion',size=80, required=True, readonly=False)                                                 ,
        'tarifa':fields.float('Tarifa (UVT)',digits=(16,2), required=True)                                                          ,
        'date':fields.date('Vigencia', required=True)                                                                               ,
        'producto':fields.selection(PRODUCTO, 'Tipo de Producto', required=True)                                                    ,
        'retencion_compra':fields.many2one('account.account','Cuenta de Compra',domain="[('type', '<>', 'view')]" )                 ,
        'retencion_venta':fields.many2one('account.account','Cuenta de Venta', domain="[('type', '<>', 'view')]")                   ,
    }
    _defaults = {
        'tarifa': lambda *a: 0.0,
    }
    
    def _check_product(self,cr,uid,ids,context={}):
        print "entro en _check_product"
        obj_iva_item = self.browse(cr,uid,ids[0])
        print "el tipo de producto que ingreso es:",obj_iva_item.producto
        cr.execute('select a.producto  from iva_item a')
        lista=cr.fetchall()
        print "los productos o servicios que hay hasta ahora son: ", lista
        ci = self.pool.get('res.country.state.city')
        #comprension de lista
        bandera=([x[0] for x in lista if x[0] == obj_iva_item.producto])
        #bandera devuelve una lista de las ocurrencias
        print"bandera es:", bandera
        if  len(bandera)>1 :
            return False
        return True

    _constraints = [
        (_check_product, 'Error ! Solo puede existir una tarifa para productos y servicios. ', ['producto'])
    ]
    
    
iva_item()



