# -*- encoding: utf-8 -*-
###########################################################################
#    Module Writen to OpenERP, Open Source Management Solution
#    Copyright (C) OpenERP Venezuela (<http://openerp.com.ve>).
#    All Rights Reserved
###############Credits######################################################
#    Coded by: Angelica Barrios angelicaisabelb@gmail.com
#              Humberto Arocha humberto@openerp.com.ve
#    Planified by: Humberto Arocha
#    Finance by: LUBCAN COL S.A.S http://www.lubcancol.com
#    Audited by: Humberto Arocha humberto@openerp.com.ve
#############################################################################
#    This program is free software: you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation, either version 3 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program.  If not, see <http://www.gnu.org/licenses/>.
##############################################################################

from osv import osv
from osv import fields
from tools.translate import _
from tools import config

REGIMEN_IVA = [('Gran_Contri', 'Gran Contribuyente')                           ,
               ('Reg_Com', 'Regimen Comun')                                    ,
               ('Reg_Simp', 'Regimen Simplificado')                            ,
               ('No_Resi', 'No Residente')                                     ,
               ('Ent_Publi', 'Entidades Publicas')                             ,
              ]

RETENEDOR =   [('Auto' , 'Autorretenedor')                                     ,
               ('No_Auto', 'No Autorretenedor')                                ,
              ]

class tax_payer_iva(osv.osv):
    _name='tax.payer.iva'
    _columns={
    'name': fields.char('Tipos de Contributentes para IVA',size=64, required=False, readonly=False)      ,
    'notes': fields.text('Notas', required=False, readonly=False)                                        ,
    'retenido_ids': fields.one2many('tax.payer.iva.supplier', 'type', 'Hijos')                           ,
    'retenerdor_ids': fields.one2many('tax.payer.iva.customer', 'type', 'Hijos')                         ,
    'retenedor':fields.selection(RETENEDOR, 'Tipo de Retenedor', required=True, readonly=False)          , 
    'iva':fields.selection(REGIMEN_IVA, 'Tipo de Contribuyente',required=True, readonly=False)           ,
    'partner_ids': fields.one2many('res.partner', 'type_iva', 'Hijos')                                   ,
    }
    
    def name_uniq(self,cr,uid,ids,context={}):
        obj_iva = self.browse(cr,uid,ids[0])
        cr.execute('select a.name  from tax_payer_iva a')
        lista=cr.fetchall()
        print lista
        #comprension de lista
        bandera=([x[0] for x in lista if x[0] == obj_iva.name])
        #bandera devuelve una lista de las ocurrencias
        print"bandera es:", bandera
        if  len(bandera)>1 :
            return False
        return True  
    
    _constraints = [
        (name_uniq, 'Error ! Este Contribuyente ya existe. ', ['name'])
    ]

    
    
    def create(self, cr, user, vals, context=None):
        """
        Update redord(s) comes in {ids}, with new value comes as {vals}
        return True on success, False otherwise   
        @param cr: cursor to database
        @param user: id of current user
        @param ids: list of record ids to be update
        @param vals: dict of new values to be set
        @param context: context arguments, like lang, time zone 
        @return: True on success, False otherwise
        """
        for reg in REGIMEN_IVA:
            if reg[0] == vals['iva']:
                vals_iva = reg[1]
                break
                
        for ret in RETENEDOR:
            if ret[0] == vals['retenedor']:
                vals_retenedor = ret[1]
                break
                
        vals['name']="%s - %s" % (vals_iva, vals_retenedor)
        return super(tax_payer_iva, self).create(cr, user, vals, context)

    def write(self, cr, user,ids, vals, context=None):
        """
        Update redord(s) comes in {ids}, with new value comes as {vals}
        return True on success, False otherwise   
        @param cr: cursor to database
        @param user: id of current user
        @param ids: list of record ids to be update
        @param vals: dict of new values to be set
        @param context: context arguments, like lang, time zone 
        @return: True on success, False otherwise
        """
        for reg in REGIMEN_IVA:
            if reg[0] == vals['iva']:
                vals_iva = reg[1]
                break
                
        for ret in RETENEDOR:
            if ret[0] == vals['retenedor']:
                vals_retenedor = ret[1]
                break
                
        vals['name']="%s - %s" % (vals_iva, vals_retenedor)
        return super(tax_payer_iva, self).write(cr, user, ids, vals, context)
  

tax_payer_iva()



