# -*- encoding: utf-8 -*-
###########################################################################
#    Module Writen to OpenERP, Open Source Management Solution
#    Copyright (C) OpenERP Venezuela (<http://openerp.com.ve>).
#    All Rights Reserved
###############Credits######################################################
#    Coded by: Angelica Barrios angelicaisabelb@gmail.com
#              Humberto Arocha humberto@openerp.com.ve
#    Planified by: Humberto Arocha
#    Finance by: LUBCAN COL S.A.S http://www.lubcancol.com
#    Audited by: Humberto Arocha humberto@openerp.com.ve
#############################################################################
#    This program is free software: you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation, either version 3 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program.  If not, see <http://www.gnu.org/licenses/>.
##############################################################################
from osv import osv
from osv import fields
from tools.translate import _
from tools import config
import time

################################################RETENCION IVA################################################

class account_invoice(osv.osv):
    _inherit = 'account.invoice'
    _columns = {

        'procesado': fields.selection([
            ('pro','Procesado')                   ,
            ('no_pro','No Procesado')             ,
            ],'Estatus', readonly=True )          ,
        'rete_iva_doc': fields.many2one('account.retention.iva', 'Documento de Retencion IVA', readonly=True)     , 
        'status_iva': fields.selection([
            ('no_cal','Retencion no Calculada')                             ,
            ('cal','Retencion Calculada')                                   ,
            ('tax_payer','No se aplica retencion entre los Contribuyentes') ,
            ('tasa','No supera la tasa')                                    ,
            ('tax','No existen impuestos')                                  ,
            ],'status',readonly=True )  
    }
    
    _defaults = {
        'procesado': lambda *a: "no_pro",
        'status_iva': lambda *a: "no_cal",
    }
   
    
    def copy(self, cr, uid, id, default=None, context=None):
        if default is None:
            default = {}
        default = default.copy()
        default.update({'rete_iva_doc':None , 'procesado':'no_pro'      , 'status_rete':'no_cal',   
                        'rete_ica_doc':None , 'procesado_ica':'no_pro'  , 'status_iva':'no_cal' ,
                        'rete_rete_doc':None, 'procesado_rete':'no_pro' , 'status_ica':'no_cal' ,
                         })
        return super(account_invoice, self).copy(cr, uid, id, default, context)
    

    
    # Metodo que verifica si se retiene impuesto para IVA segun la tabla de contribuyentes y
    #verifica que se encuentre en la tabla de contribuyentes 
    def _validar_Contribuyente_iva(self, cr, uid, ids, context=None):
        account=False
        print "Se evalua si se aplica retencion de IVA"
        invoices = self.browse(cr, uid, ids, context=None) # toma los objetos de tipo invoice para recorrerlos dentro de un for
        for inv in invoices: 
            if inv.procesado=="pro":
                print 'YA EL DOCUMENTO ESTA PROCESADO'
                raise osv.except_osv(_('Atencion !'), _('El Documento ya esta Procesado!!!'))           
                continue
            vendedor_iva = False
            comprador_iva = False
            if inv.type == 'in_invoice' or inv.type == 'in_refund': #si se trata de una factura de COMPRA
                #~ si estoy aqui dentro es porque soy un comprador,
                print "Se trata de una factura de Compra"
                comprador_iva =inv.company_id.partner_id.type_iva.id  
                vendedor_iva = inv.partner_id.type_iva.id
                print "el comprador para iva es:"
                print inv.company_id.partner_id.type_iva.name 
                print "el vendedor para iva es:"
                print inv.partner_id.type_iva.name     
            elif inv.type == 'out_invoice' or inv.type == 'out_refund': #si se trata de una factura de VENTA
                #~ si estoy aqui dentro es porque soy un vendedor, 
                print "Se trata de una factura de Venta"
                comprador_iva = inv.partner_id.type_iva.id
                vendedor_iva = inv.company_id.partner_id.type_iva.id
                print "el comprador para iva es:"
                print inv.partner_id.type_iva.name
                print "el vendedor para iva es:"
                print inv.company_id.partner_id.type_iva.name
                 
            if vendedor_iva== False:
                raise osv.except_osv(_('Atencion !'), _('Debe establecer el tipo de Contribuyente IVA en la Pestaña de Contribuyentes para el Vendedor !!!'))           
            if comprador_iva== False:
                raise osv.except_osv(_('Atencion !'), _('Debe establecer el tipo de Contribuyente IVA en la Pestaña de Contribuyentes para el Comprador !!!'))

            tabla_contribuyente_iva = self.pool.get('tax.payer.iva.supplier')   
            t_ids_iva = tabla_contribuyente_iva.search(cr, uid, [('type','=',vendedor_iva)], limit = 1)      
            tipo_de_vendedor_iva = tabla_contribuyente_iva.browse(cr, uid, t_ids_iva, context=None)    
            vendedor_vale_iva = False
            comprador_vale_iva = False
            retener_iva=False        
            for cada_vendedor_iva in tipo_de_vendedor_iva:
                if cada_vendedor_iva.type.id == vendedor_iva:
                    #~ si estoy aqui es porque este es el tipo de vendedor
                    vendedor_vale_iva = True
                    for cada_comprador_iva in cada_vendedor_iva.retenedor_ids:
                        if cada_comprador_iva.type.id == comprador_iva:
                            comprador_vale_iva = True
                            #~ si estoy aqui es porque este es el tipo de comprador
                            tarifa=cada_comprador_iva.tar.tarifa
                            print "la retencion que aplica para iva es:"
                            print tarifa
                            if tarifa > 0:
                                retener_iva=True
                                print"si retengo iva porque la tarifa no es 0%"         
                    break # cortamos aqui el primer ciclo porque ya hemos obtenido lo que deseabamos
                
            contribuyente_iva = self.pool.get('tax.payer.iva') 
            if vendedor_vale_iva== False:
                raise osv.except_osv(_('Atencion !'), _('El tipo de Contribuyente del Vendedor [%s] \n no esta registrado en la Tabla de Contribuyentes de IVA, \n Vaya a la Tabla de Contribuyentes de IVA y registre dicho Tipo !!!')%(contribuyente_iva.browse(cr, uid, vendedor_iva).name))
            if comprador_vale_iva== False:
                raise osv.except_osv(_('Atencion !'), _('El tipo de Contribuyente del Comprador [%s] \n no esta registrado en la Tabla de Contribuyentes de IVA, \n para el tipo de Vendedor [%s] de esta Factura \n Vaya a la Tabla de Contribuyentes IVA y registre dicho Tipo !!!')%(contribuyente_iva.browse(cr, uid, comprador_iva).name,contribuyente_iva.browse(cr, uid, vendedor_iva).name))     
            
            if retener_iva==True: #se llama al metodo de retener iva
                self._ver_Prod_Servi(cr, uid, inv.id, tarifa)
            else: #no aplica retencion por contribuyentes
                inv.write({'status_iva':"tax_payer" })
        return True
            

    #Metodo que separa los productos de los servicios en la linea de la factura 
    #este es utilizado para el calculo de la retencion del IVA
    def _ver_Prod_Servi(self, cr, uid, inv_id, tarifa_aplica, context=None):
        cuenta={}
        inv = self.browse(cr, uid, inv_id, context=None)
        uvt = self.pool.get('l10n.co.uvt')
        iva_item = self.pool.get('iva.item')
        ret_iva_prod = False
        ret_iva_serv = False
        productos=[]
        servicios=[]
        costo_producto=0
        costo_servicio=0
        tarifa_moneda_p=0
        tarifa_moneda_s=0
        
        tarifa_prod = iva_item.search(cr, uid,[('producto','=','p'), ('date','<=', inv.date_invoice)], limit = 1, )
        tarifa_serv = iva_item.search(cr, uid,[('producto','=','s'), ('date','<=', inv.date_invoice)], limit = 1, )
        if not tarifa_prod:
            raise osv.except_osv(_('Atencion !'), _('Debe de ingresar la tarifa de los Productos en el baremo IVA !!!'))
        if not tarifa_serv:
            raise osv.except_osv(_('Atencion !'), _('Debe de ingresar la tarifa de los Servicios en el baremo IVA !!!'))
        
        tipo_factura=inv.type
        #para las cuentas contables
        if tipo_factura == 'in_invoice' or inv.type == 'in_refund': #si se trata de una factura de COMPRA
            cuenta['productos']=iva_item.browse(cr, uid, tarifa_prod[0], context=None).retencion_compra \
                                        and iva_item.browse(cr, uid, tarifa_prod[0], context=None).retencion_compra.id or False
            cuenta['servicios']=iva_item.browse(cr, uid, tarifa_serv[0], context=None).retencion_compra  \
                                        and iva_item.browse(cr, uid, tarifa_serv[0], context=None).retencion_compra.id or False
            if not cuenta['productos']:
                raise osv.except_osv(_('Atencion !'), _('Debe de ingresar la cuenta de Compra para los productos en el baremo IVA !!!'))
            if not cuenta['servicios']:
                raise osv.except_osv(_('Atencion !'), _('Debe de ingresar la cuenta de Compra para los servicios en el baremo IVA !!!'))
            
        elif inv.type == 'out_invoice' or inv.type == 'out_refund': #si se trata de una factura de VENTA
            cuenta['productos']=iva_item.browse(cr, uid, tarifa_prod[0], context=None).retencion_venta \
                                        and iva_item.browse(cr, uid, tarifa_prod[0], context=None).retencion_venta.id or False
            cuenta['servicios']=iva_item.browse(cr, uid, tarifa_serv[0], context=None).retencion_venta \
                                        and iva_item.browse(cr, uid, tarifa_serv[0], context=None).retencion_venta.id or False
            if not cuenta['productos']:
                raise osv.except_osv(_('Atencion !'), _('Debe de ingresar la cuenta de Venta para los productos en el baremo IVA !!!'))
            if not cuenta['servicios']:
                raise osv.except_osv(_('Atencion !'), _('Debe de ingresar la cuenta de Venta para los servicios en el baremo IVA !!!'))           
            
        print "como es una factura de tipo: ",tipo_factura
        print"la cuenta para los productos es: ", cuenta['productos']
        print"la cuenta para los servicios es: ", cuenta['servicios']     
        
        for line in inv.invoice_line:
            tipo_producto=line.concept_retention_iva
            
            if (tipo_producto=="p"):
                productos.append(line.id)
                print "esto es un producto"
                costo_producto+=line.price_subtotal       
            elif tipo_producto=="s":
                servicios.append(line.id)
                print "esto es un servicio"
                costo_servicio+=line.price_subtotal               
            
        print "tarifa_prod", tarifa_prod,
        if len(tarifa_prod)==1 and costo_producto > 0:
            uvt_prod = iva_item.browse(cr, uid, tarifa_prod[0], context=None).tarifa
#            print 'uvt_prod ', uvt_prod, '\n'
            tarifa_moneda_p = uvt.compute_uvt_to_money(cr, uid, uvt_prod, inv.date_invoice, context)#metodo que transforma los UVT en pesos
            print 'tarifa_moneda para productos ', tarifa_moneda_p, '\n'
            if costo_producto >= tarifa_moneda_p:
                ret_iva_prod = True
        elif len(tarifa_prod)==0 and costo_producto > 0:
            raise osv.except_osv(_('Atencion !'), _('No se ha estipulado una Tasa de IVA sobre Productos con Vigencia para la Fecha: %s, \ndirijase a Baremo IVA') %(inv.date_invoice))
            
        print "tarifa_serv", tarifa_serv,
        if len(tarifa_serv)==1 and costo_servicio > 0:
            uvt_serv = iva_item.browse(cr, uid, tarifa_serv[0], context=None).tarifa
            print 'uvt_serv ', uvt_serv, '\n'
            tarifa_moneda_s = uvt.compute_uvt_to_money(cr, uid, uvt_serv, inv.date_invoice, context)
            print 'tarifa_moneda ', tarifa_moneda_s, '\n'
            if costo_servicio >= tarifa_moneda_s:
                ret_iva_serv = True
        elif len(tarifa_serv)==0 and costo_servicio > 0:
            raise osv.except_osv(_('Atencion !'), _('No se ha estipulado una Tasa de IVA sobre Servicios con Vigencia para la Fecha: %s, \ndirijase a Baremo IVA') %(inv.date_invoice))
        
        if ret_iva_prod or ret_iva_serv: #si retiene para productos o servicios
            gen_ret_iva=False
            invoice_line = self.browse(cr, uid, inv.id, context=None).invoice_line
            for line in invoice_line:
                ################para las notas de credito################    
                if inv.type=="out_refund" or inv.type=="in_refund" :#para notas de credito
                    if inv.parent_id and inv.parent_id.procesado=="pro" : #si tiene factura padre y tiene retencion   
                        if line.id in productos:
                            res = self.CalcularTax(cr, uid, inv.id,line,tarifa_aplica, context=None)
                            if res['monto_retener']>0:
                                #ENCABEZADO DE LA RETENCION
                                retention_id=self.crear_retencion_iva(cr, uid, inv.id, tarifa_aplica)
                                gen_ret_iva=True
                                break     
                        if line.id in servicios:
                            res = self.CalcularTax(cr, uid, inv.id,line,tarifa_aplica, context=None)
                            if res['monto_retener']>0:
                                #ENCABEZADO DE LA RETENCION
                                retention_id=self.crear_retencion_iva(cr, uid, inv.id, tarifa_aplica)
                                gen_ret_iva=True
                                break
                    else:
                        raise osv.except_osv(_('Atencion !'), _('La Nota de Credito no tiene factura asociada o aun esta no ha sido \n retenida, no podra retener!!!'))     
                else: #si son facturas
                    if line.id in productos:
                        res = self.CalcularTax(cr, uid, inv.id,line,tarifa_aplica, context=None)
                        if res['monto_retener']>0:
                            #ENCABEZADO DE LA RETENCION
                            retention_id=self.crear_retencion_iva(cr, uid, inv.id, tarifa_aplica)
                            gen_ret_iva=True
                            break     
                    if line.id in servicios:
                        res = self.CalcularTax(cr, uid, inv.id,line,tarifa_aplica, context=None)
                        if res['monto_retener']>0:
                            #ENCABEZADO DE LA RETENCION
                            retention_id=self.crear_retencion_iva(cr, uid, inv.id, tarifa_aplica)
                            gen_ret_iva=True
                            break
            if gen_ret_iva==True: #si existen impuestos
                # CREAR LINEAS DE LA RETENCION
                if inv.type=="out_refund" or inv.type=="in_refund" :#para notas de credito:
                    self.crear_retencion_iva_line_refund( cr, uid, productos       , 
                                                            servicios       , 
                                                            ret_iva_prod    , 
                                                            ret_iva_serv    ,
                                                            inv.id          , 
                                                            retention_id    , 
                                                            tarifa_prod     ,
                                                            tarifa_serv     , 
                                                            tarifa_aplica   , 
                                                            tarifa_moneda_s ,
                                                            tarifa_moneda_p ,
                                                            cuenta ,context=None)
                else: #para facturas
                    self.crear_retencion_iva_line( cr, uid, productos, 
                                                            servicios       , 
                                                            ret_iva_prod    , 
                                                            ret_iva_serv    ,
                                                            inv.id          , 
                                                            retention_id    , 
                                                            tarifa_prod     ,
                                                            tarifa_serv     , 
                                                            tarifa_aplica   , 
                                                            tarifa_moneda_s ,
                                                            tarifa_moneda_p ,
                                                            cuenta ,context=None)
                inv.write({'procesado':"pro"          ,
                           'rete_iva_doc':retention_id,
                           'status_iva':"cal"         ,
                })
            else:#si no existen impuestos
                inv.write({'status_iva':"tax" })

        else:#no retiene para productos ni para servicios
            inv.write({'status_iva':"tasa" })
        return True
  
        
    def crear_retencion_iva(self, cr, uid, inv_id, tarifa_aplica, context=None):
        print "Metodo de retencion iva"
        rete_iva=self.pool.get('account.retention.iva')
        codigo=rete_iva._get_seq_code(cr, uid, context=None) #se llama al metodo para obtener el numero de secuencia del CODE
        inv = self.browse(cr, uid, inv_id, context=None)
        if inv.type == 'in_invoice' or inv.type == 'in_refund': #si es una factura de compra
            if not inv.reference:
                referencia="-"
            else:
                referencia=inv.reference
            nombre="RETENCION DE IVA %s DEL DOCUMENTO %s CODIGO: %s" %(inv.partner_id.name ,referencia, codigo)
        else: #si es una factura de venta
            if not inv.number:
                number="-"
            else:
                number=inv.number
            nombre="RETENCION DE IVA %s DEL DOCUMENTO %s CODIGO: %s" %(inv.partner_id.name ,number, codigo)
        #ENCABEZADO DE RETENCIONES
        retention_id=rete_iva.create(cr, uid,{
                                'name':nombre                           ,
                                'period_id': None                       ,
                                'company_id': inv.company_id.id         ,
                               # 'code': None                           , se genera en el defaul de account.retention.iva
                                'invoice_id': inv.id                    ,
                                'type':inv.type                         ,
                                'account_id':inv.account_id.id          ,
                                'partner_id':inv.partner_id.id          ,
                                'currency_id':inv.currency_id.id        , 
                                #'journal_id':inv.journal_id.id         ,#toma el defaul para el diario de iva
                                'move_id':None                          ,
                                #'state':"draft"                        ,# toma el defaul del modelo 
                                'date_ret':None                         ,
                                'date':time.strftime('%Y-%m-%d')        ,
                                'porc_retener':tarifa_aplica            ,                                                             
                                },context=None)    
        return retention_id
    
        
    def crear_retencion_iva_line( self, cr, uid, productos, servicios, ret_iva_prod, ret_iva_serv, inv_id,retention_id, tarifa_prod,tarifa_serv, tarifa_aplica, tarifa_moneda_s,tarifa_moneda_p, cuenta, context=None):
        print "Metodo de retencion de linea......."
        rete_iva_line=self.pool.get('account.retention.iva.line')
        self.pool.get('account.retention.iva') 
        invoice_line = self.browse(cr, uid, inv_id, context=None).invoice_line
        if ret_iva_prod==True: #para productos
            for line in invoice_line:
                if line.id in productos:
                    #metodo para calcular el TAX por linea para los productos hay que validar que los productos tengan un tax
                    if len (line.invoice_line_tax_id)!=None:
                        res = self.CalcularTax(cr, uid, inv_id,line,tarifa_aplica, context=None)
                        base_=res['base'] 
                        subtotal=res['subtotal']
                        monto_rete=res['monto_retener']
                        if monto_rete>0:    
                            rete_iva_line.create(cr, uid,{
                                'name':line.name                             ,
                                'retention_id':retention_id                  ,
                                'move_line_id': None                         ,
                                'producto_id':line.product_id and line.product_id.id or False,
                                'invoice_line_id':line.id                    ,                         
                                'baremo_iva':tarifa_moneda_p                 ,
                                'subtotal':subtotal                          ,
                                'base':base_                                 ,
                                'monto_retener':monto_rete                   ,
                                'account_id': cuenta['productos']            , 
                                'concept_retention_iva':'p'                  ,                                                            
                                        },context=None)                                         
        if ret_iva_serv==True: #para los servicios
            for line in invoice_line:
                if line.id in servicios:
                    #metodo para calcular el TAX por linea para los servicios
                    if len (line.invoice_line_tax_id)!=None: 
                        res = self.CalcularTax(cr, uid, inv_id,line,tarifa_aplica, context=None)
                        base_=res['base'] 
                        subtotal=res['subtotal']
                        monto_rete=res['monto_retener']
                        if monto_rete>0:
                            rete_iva_line.create(cr, uid,{
                                'name':line.name                             ,
                                'retention_id':retention_id                  ,
                                'move_line_id': None                         ,
                                'producto_id':line.product_id and line.product_id.id or False,
                                'invoice_line_id':line.id                    ,                         
                                'baremo_iva':tarifa_moneda_s                 ,
                                'subtotal':subtotal                          ,
                                'base':base_                                 ,
                                'monto_retener':monto_rete                   ,
                                'account_id': cuenta['servicios']            , 
                                'concept_retention_iva':'s'                  ,                       
                                        },context=None)                              
        return True

    def crear_retencion_iva_line_refund( self, cr, uid, productos, servicios, ret_iva_prod, ret_iva_serv, inv_id,retention_id, tarifa_prod,tarifa_serv, tarifa_aplica, tarifa_moneda_s,tarifa_moneda_p, cuenta, context=None):
        print "Metodo de retencion de linea......."
        rete_iva_line=self.pool.get('account.retention.iva.line')
        self.pool.get('account.retention.iva') 
        invoice_line = self.browse(cr, uid, inv_id, context=None).invoice_line
        if ret_iva_prod==True: #para productos
            for line in invoice_line:
                if line.id in productos:
                    #metodo para calcular el TAX por linea para los productos hay que validar que los productos tengan un tax
                    if len (line.invoice_line_tax_id)!=None:
                        res = self.CalcularTax(cr, uid, inv_id,line,tarifa_aplica, context=None)
                        base_=res['base'] 
                        subtotal=res['subtotal']
                        monto_rete=res['monto_retener']
                        if monto_rete>0:    
                            rete_iva_line.create(cr, uid,{
                                'name':line.name                             ,
                                'retention_id':retention_id                  ,
                                'move_line_id': None                         ,
                                'producto_id':line.product_id and line.product_id.id or False,
                                'invoice_line_id':line.id                    ,                         
                                'baremo_iva':tarifa_moneda_p                 ,
                                'subtotal':subtotal                          ,
                                'base':base_                                 ,
                                'monto_retener':-1*monto_rete                ,
                                'account_id': cuenta['productos']            , 
                                'concept_retention_iva':'p'                  ,                                                            
                                        },context=None)                                         
        if ret_iva_serv==True: #para los servicios
            for line in invoice_line:
                if line.id in servicios:
                    #metodo para calcular el TAX por linea para los servicios
                    if len (line.invoice_line_tax_id)!=None: 
                        res = self.CalcularTax(cr, uid, inv_id,line,tarifa_aplica, context=None)
                        base_=res['base'] 
                        subtotal=res['subtotal']
                        monto_rete=res['monto_retener']
                        if monto_rete>0:
                            rete_iva_line.create(cr, uid,{
                                'name':line.name                             ,
                                'retention_id':retention_id                  ,
                                'move_line_id': None                         ,
                                'producto_id':line.product_id and line.product_id.id or False,
                                'invoice_line_id':line.id                    ,                         
                                'baremo_iva':tarifa_moneda_s                 ,
                                'subtotal':subtotal                          ,
                                'base':base_                                 ,
                                'monto_retener':-1*monto_rete                ,
                                'account_id': cuenta['servicios']            , 
                                'concept_retention_iva':'s'                  ,                       
                                        },context=None)                              
        return True




    def CalcularTax(self, cr, uid, inv_id,line,tarifa_aplica, context=None):
        res = {}
        tax_obj = self.pool.get('account.tax') #impuesto
        cur_obj = self.pool.get('res.currency') #moneda
        inv = self.pool.get('account.invoice').browse(cr, uid, inv_id, context)
        company_currency = inv.company_id.currency_id.id
        tax_grouped = {}
        val={}

        for tax in tax_obj.compute(cr, uid, line.invoice_line_tax_id, (line.price_unit* (1-(line.discount or 0.0)/100.0)), line.quantity, inv.address_invoice_id.id, line.product_id, inv.partner_id):

            val['invoice_id'] = inv.id
            val['name'] = tax['name']
            val['amount'] = tax['amount']
            val['manual'] = False
            val['sequence'] = tax['sequence']
            val['base'] = tax['price_unit'] * line['quantity']

            if inv.type in ('out_invoice','in_invoice'):
                val['base_code_id'] = tax['base_code_id']
                val['tax_code_id'] = tax['tax_code_id']
                val['base_amount'] = cur_obj.compute(cr, uid, inv.currency_id.id, company_currency, val['base'] * tax['base_sign'], context={'date': inv.date_invoice or time.strftime('%Y-%m-%d')}, round=False)
                val['tax_amount'] = cur_obj.compute(cr, uid, inv.currency_id.id, company_currency, val['amount'] * tax['tax_sign'], context={'date': inv.date_invoice or time.strftime('%Y-%m-%d')}, round=False)
                val['account_id'] = tax['account_collected_id'] or line.account_id.id
            else:
                val['base_code_id'] = tax['ref_base_code_id']
                val['tax_code_id'] = tax['ref_tax_code_id']
                val['base_amount'] = cur_obj.compute(cr, uid, inv.currency_id.id, company_currency, val['base'] * tax['ref_base_sign'], context={'date': inv.date_invoice or time.strftime('%Y-%m-%d')}, round=False)
                val['tax_amount'] = cur_obj.compute(cr, uid, inv.currency_id.id, company_currency, val['amount'] * tax['ref_tax_sign'], context={'date': inv.date_invoice or time.strftime('%Y-%m-%d')}, round=False)
                val['account_id'] = tax['account_paid_id'] or line.account_id.id

            key = (val['tax_code_id'], val['base_code_id'], val['account_id'])
            if not key in tax_grouped:
                tax_grouped[key] = val
            else:
                tax_grouped[key]['amount'] += val['amount']
                tax_grouped[key]['base'] += val['base']
                tax_grouped[key]['base_amount'] += val['base_amount']
                tax_grouped[key]['tax_amount'] += val['tax_amount']
        
        if not len(line.invoice_line_tax_id)==0:
            res['base'] = val['tax_amount']
            res['subtotal'] = val['base_amount']
            res['monto_retener'] = (tarifa_aplica/100)* val['tax_amount'] 
        else:
            res['base'] = 0
            res['monto_retener'] = 0
            res['subtotal']= line.price_subtotal
        
        return res


account_invoice()
