# -*- encoding: utf-8 -*-
###########################################################################
#    Module Writen to OpenERP, Open Source Management Solution
#    Copyright (C) OpenERP Venezuela (<http://openerp.com.ve>).
#    All Rights Reserved
###############Credits######################################################
#    Coded by: Angelica Barrios angelicaisabelb@gmail.com
#              Humberto Arocha humberto@openerp.com.ve
#    Planified by: Humberto Arocha
#    Finance by: LUBCAN COL S.A.S http://www.lubcancol.com
#    Audited by: Humberto Arocha humberto@openerp.com.ve
#############################################################################
#    This program is free software: you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation, either version 3 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program.  If not, see <http://www.gnu.org/licenses/>.
##############################################################################

import time
from report import report_sxw
from osv import osv
import pooler

class rep_comprobante_rete_anual(report_sxw.rml_parse):

    def __init__(self, cr, uid, name, context):
        super(rep_comprobante_rete_anual, self).__init__(cr, uid, name, context)    
        self.localcontext.update({
            'time': time,
            'get_tipo': self.get_tipo,
            'get_rif': self._get_rif
        })

    def get_tipo(self, idp=None):
        if not idp:
            return []
        print idp
        res=" "
        if idp == 'in_invoice' or idp == 'in_refund':
            res="Compra"
        elif idp == 'out_invoice' or idp == 'out_refund':
            res="Venta"     
            
        return res 


    def _get_rif(self, vat=''):
        if not vat:
            return []
        return vat[2:].replace(' ', '')
    
      
report_sxw.report_sxw(
    'report.comprobante.retencion.rete.anual'                       ,
    'reporte.anual.rete'                                            ,
    'addons/l10n_co_retefuente/report/comprobante_rete_anual.rml'   ,
    parser=rep_comprobante_rete_anual                                ,
)      
