# -*- encoding: utf-8 -*-
###########################################################################
#    Module Writen to OpenERP, Open Source Management Solution
#    Copyright (C) OpenERP Venezuela (<http://openerp.com.ve>).
#    All Rights Reserved
###############Credits######################################################
#    Coded by: Angelica Barrios angelicaisabelb@gmail.com
#              Humberto Arocha humberto@openerp.com.ve
#    Planified by: Humberto Arocha
#    Finance by: LUBCAN COL S.A.S http://www.lubcancol.com
#    Audited by: Humberto Arocha humberto@openerp.com.ve
#############################################################################
#    This program is free software: you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation, either version 3 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program.  If not, see <http://www.gnu.org/licenses/>.
##############################################################################
from osv import osv
from osv import fields
from tools.translate import _
from tools import config

RETENEDOR =   [('Auto' , 'Autorretenedor')                                      ,
               ('No_Auto', 'No Autorretenedor')                                 ,
              ]

RETEFUENTE =   [('Natural' , 'Natural')                                         ,
               ('Juridico', 'Juridico')                                         ,
              ]

DECLARA =     [('Declara' , 'Declarante')                                       ,
               ('No_Declara', 'No Declarante')                                  ,
              ]

NACIONALIDAD =   [('N_N' , 'Nacional')                                          ,
                  ('N_E', 'Extranjero')                                         ,
                 ]
                 
class tax_payer_renta(osv.osv):
    _name='tax.payer.renta'
    _columns={
    'name': fields.char('Tipos de Contributentes para Retefuente',size=64, required=False, readonly=False)    ,
    'notes': fields.text('Notas', required=False, readonly=False)                                             ,
    'retenido_ids': fields.one2many('tax.payer.renta.supplier', 'type', 'Hijos')                              ,
    'retenerdor_ids': fields.one2many('tax.payer.renta.customer', 'type', 'Hijos')                            ,
    'regimen_retenedor':fields.selection(RETENEDOR, 'Tipo de Retenedor')                                      , 
    'nat_jur':fields.selection(RETEFUENTE, 'Tipo de Persona')                                                 , 
    'declaracion':fields.selection(DECLARA, 'Tipo de Declaracion')                                            ,     
    'nacionalidad':fields.selection(NACIONALIDAD, 'Nacionalidad')                                             , 
    'partner_ids': fields.one2many('res.partner', 'type_rete', 'Hijos')                                       ,    
    }
     
    def name_uniq(self,cr,uid,ids,context={}):
        obj_rete = self.browse(cr,uid,ids[0])
        cr.execute('select a.name  from tax_payer_renta a')
        lista=cr.fetchall()
        print lista
        #comprension de lista
        bandera=([x[0] for x in lista if x[0] == obj_rete.name])
        #bandera devuelve una lista de las ocurrencias
        print"bandera es:", bandera
        if  len(bandera)>1 :
            return False
        return True  
    
    _constraints = [
        (name_uniq, 'Error ! Este Contribuyente ya existe. ', ['name'])
    ]    

    #metodo para sobreescribir el atributo name de la clase tax_payer_renta, representando el tipo de contribuyente para RENTA
    def create(self, cr, user, vals, context=None):

        for ret in RETENEDOR:
            if ret[0] == vals['regimen_retenedor']:
                regimen_retenedor = ret[1]
                break

        for ret in RETEFUENTE:
            if ret[0] == vals['nat_jur']:
                nat_jur = ret[1]
                break

        for ret in DECLARA:
            if ret[0] == vals['declaracion']:
                declaracion = ret[1]
                break

        for ret in NACIONALIDAD:
            if ret[0] == vals['nacionalidad']:
                nacionalidad = ret[1]
                break

        vals['name']="%s , %s , %s , %s" % (regimen_retenedor, nat_jur, declaracion, nacionalidad)
        return super(tax_payer_renta, self).create(cr, user, vals, context)    
    def write(self, cr, user,ids, vals, context=None):

        for ret in RETENEDOR:
            if ret[0] == vals['regimen_retenedor']:
                regimen_retenedor = ret[1]
                break

        for ret in RETEFUENTE:
            if ret[0] == vals['nat_jur']:
                nat_jur = ret[1]
                break

        for ret in DECLARA:
            if ret[0] == vals['declaracion']:
                declaracion = ret[1]
                break

        for ret in NACIONALIDAD:
            if ret[0] == vals['nacionalidad']:
                nacionalidad = ret[1]
                break

        vals['name']="%s , %s , %s , %s" % (regimen_retenedor, nat_jur, declaracion, nacionalidad)
        return super(tax_payer_renta, self).write(cr, user, ids, vals, context)
  
tax_payer_renta()

