# -*- encoding: utf-8 -*-
###########################################################################
#    Module Writen to OpenERP, Open Source Management Solution
#    Copyright (C) OpenERP Venezuela (<http://openerp.com.ve>).
#    All Rights Reserved
###############Credits######################################################
#    Coded by: Angelica Barrios angelicaisabelb@gmail.com
#              Humberto Arocha humberto@openerp.com.ve
#    Planified by: Humberto Arocha
#    Finance by: LUBCAN COL S.A.S http://www.lubcancol.com
#    Audited by: Humberto Arocha humberto@openerp.com.ve
#############################################################################
#    This program is free software: you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation, either version 3 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program.  If not, see <http://www.gnu.org/licenses/>.
##############################################################################

import wizard
import osv
import pooler
import time

_transaction_form = '''<?xml version="1.0"?>
<form string=" Seleccione el periodo fiscal">
<hpaned/>
    <group colspan="2" col="2">
       <field name="fiscalyear_id"/>
    </group>
<hpaned/>
</form>'''

_transaction_fields = {
    'fiscalyear_id': {
        'string': 'Periodo Fiscal'          ,
        'type': 'many2one'                  ,
        'relation': 'account.fiscalyear'    ,
        'required': True
      },        
}

def _crear_modelo_reporte_anual_rete(self, cr, uid, data, context):
    print" Metodo que genera el modelo de reporte anual rete desde el wizar"
    res={}
    periodo=data['form']['fiscalyear_id']
    pool= pooler.get_pool(cr.dbname)
    year=pool.get('account.fiscalyear').browse(cr, uid, periodo)
    reporte=pool.get('reporte.anual.rete')
    reporte_w=pool.get('reporte.anual.rete')
    rete_rete=pool.get('account.retention.rete')
    print "el periodo fiscal es:", year.name
    bandera=0   
    vector=[]
    linea=[]
    
    for i in year.period_ids: #para todos los periodos
        print "el periodo es: ", i.name
        rete = rete_rete.search(cr, uid, [('period_id', '=',i.id)])
        if len(rete)!=0: #si esta en un periodo
            print rete
            vector=rete
            #vector.append(rete)
            bandera=1 
    if bandera==1: #si hay periodo asociados a ese ano en el modelo de retencion, si no entra aqui se manda una excepcion
        lines = (6,0,vector) 
        #http://openobject.com/wiki/index.php/Developers:Developper%27s_Book/Objects/ObjectsAccess/ObjectsWritingValues
#        * 0: create
#        * 1: write
#        * 2: unlink
#        * 6: set the link to a list of IDs given in the third argument (values) 
        linea.append(lines)
        print linea
        r=reporte.create(cr, uid,{
                            'date_genera':time.strftime('%Y-%m-%d')        ,
                            'fiscalyear_id': periodo                       ,
                            'rete_rete_ids': linea                         ,                                 
                            })
    return res



class wizard_rete (wizard.interface):

    states = {
        'init': {
            'actions': [],
            'result': {'type': 'form'              , 
                       'arch':_transaction_form    ,  
                       'fields':_transaction_fields, 
                       'state':[('end','Cancel'),('crear','Crear')]}
        },
        
        'crear': {
        'actions': [],
        'result': {'type': 'action',
                    'action':_crear_modelo_reporte_anual_rete ,
                   'state':'print_report'}
        },
    
         'print_report' : {
         'actions' : []              ,
         'result' : {'type' : 'print',
                     'report':'comprobante.retencion.rete.anual_wizard',
                     'state' : 'end'}
        }, 
    }

 
wizard_rete('account.ret.rete.xml')






