# -*- encoding: utf-8 -*-
###########################################################################
#    Module Writen to OpenERP, Open Source Management Solution
#    Copyright (C) OpenERP Venezuela (<http://openerp.com.ve>).
#    All Rights Reserved
###############Credits######################################################
#    Coded by: Angelica Barrios angelicaisabelb@gmail.com
#              Humberto Arocha humberto@openerp.com.ve
#    Planified by: Humberto Arocha
#    Finance by: LUBCAN COL S.A.S http://www.lubcancol.com
#    Audited by: Humberto Arocha humberto@openerp.com.ve
#############################################################################
#    This program is free software: you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation, either version 3 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program.  If not, see <http://www.gnu.org/licenses/>.
##############################################################################
from osv import osv
from osv import fields
from tools.translate import _
from tools import config
import time
################################################RETENCION RETEFUENTE################################################
class account_invoice(osv.osv):
    _inherit = 'account.invoice'
    _columns = {

        'procesado_rete': fields.selection([
            ('pro','Procesado')                   ,
            ('no_pro','No Procesado')             ,
            ],'Estatus', readonly=True )          ,
        'rete_rete_doc': fields.many2one('account.retention.rete', 'Documento de Retencion Rete', readonly=True)     , 
        'status_rete': fields.selection([
            ('no_cal','Retencion no Calculada')                             ,
            ('cal','Retencion Calculada')                                   ,
            ('tax_payer','No se aplica retencion entre los Contribuyentes') ,
            ('tasa','No supera la tasa')                                    ,
            ],'status',readonly=True )                                      ,     
    }
    
    _defaults = {
        'procesado_rete': lambda *a: "no_pro",
        'status_rete': lambda *a: "no_cal",
    }

    def copy(self, cr, uid, id, default=None, context=None):
        if default is None:
            default = {}
        default = default.copy()
        default.update({'rete_iva_doc':None , 'procesado':'no_pro'      , 'status_rete':'no_cal',   
                        'rete_ica_doc':None , 'procesado_ica':'no_pro'  , 'status_iva':'no_cal' ,
                        'rete_rete_doc':None, 'procesado_rete':'no_pro' , 'status_ica':'no_cal' ,
                         })
        return super(account_invoice, self).copy(cr, uid, id, default, context)  
    
    # Metodo que verifica si se retiene impuesto para RETEFUENTE segun la tabla de contribuyentes y
    #verifica que se encuentre en la tabla de contribuyentes 
    def _validar_Contribuyente_rete(self, cr, uid, ids, context=None):
        res = {}
        print "se evalua si se aplica retencion de RETE"
        invoices = self.browse(cr, uid, ids, context=None) # toma los objetos de tipo invoice para recorrerlos dentro de un for
        for inv in invoices:      
            if inv.type == 'in_invoice' or inv.type == 'in_refund': #si se trata de una factura de compra
                #~ si estoy aqui dentro es porque soy un comprador, 
                tipo="compra"
                print "Se trata de una factura de Compra"
                comprador_rete =inv.company_id.partner_id.type_rete.id  
                vendedor_rete = inv.partner_id.type_rete.id
                t_nat_jur_rete=inv.partner_id.type_rete.nat_jur #tipo natural juridico para el vendedor
                print "el comprador para retefuente es:"
                print inv.company_id.partner_id.type_rete.name 
                print "el vendedor para retefuente es:"
                print inv.partner_id.type_rete.name
                
            elif inv.type == 'out_invoice' or inv.type == 'out_refund': #si se trata de una factura de venta
                #~ si estoy aqui dentro es porque soy un vendedor,
                tipo="venta"
                print "Se trata de una factura de Venta"
                comprador_rete = inv.partner_id.type_rete.id
                vendedor_rete = inv.company_id.partner_id.type_rete.id
                t_nat_jur_rete=inv.company_id.partner_id.type_rete.nat_jur #tipo natural juridico para el vendedor
                print "el comprador para retefuente es:"
                print inv.partner_id.type_rete.name
                print "el vendedor para retefuente es:"
                print inv.company_id.partner_id.type_rete.name
        if vendedor_rete== False:
            raise osv.except_osv(_('Atencion !'), _('Debe establecer el tipo de Contribuyente RETE en la Pestaña de Contribuyentes para el Vendedor !!!'))           
        if comprador_rete== False:
            raise osv.except_osv(_('Atencion !'), _('Debe establecer el tipo de Contribuyente RETE en la Pestaña de Contribuyentes para el Comprador !!!'))
        tabla_contribuyente_rete = self.pool.get('tax.payer.renta.supplier')   
        t_ids_rete = tabla_contribuyente_rete.search(cr, uid, [('type','=',vendedor_rete)], limit = 1)      
        tipo_de_vendedor_rete = tabla_contribuyente_rete.browse(cr, uid, t_ids_rete, context=None)    
        vendedor_vale_rete = False
        comprador_vale_rete = False      
        for cada_vendedor_rete in tipo_de_vendedor_rete:
            if cada_vendedor_rete.type.id == vendedor_rete:
                #~ si estoy aqui es porque este es el tipo de vendedor
                vendedor_vale_rete = True
                for cada_comprador_rete in cada_vendedor_rete.retenedor_ids:
                    if cada_comprador_rete.type.id == comprador_rete:
                        comprador_vale_rete = True
                        #~ si estoy aqui es porque este es el tipo de comprador
                        res['aplica_rta'] = cada_comprador_rete.bool_renta
                        print "la retencion que aplica para rete es:"
                        print cada_comprador_rete.bool_renta
                break # cortamos aqui el primer ciclo porque ya hemos obtenido lo que deseabamos
            
        contribuyente_rete = self.pool.get('tax.payer.renta') 
        if vendedor_vale_rete== False:
            raise osv.except_osv(_('Atencion !'), _('El tipo de Contribuyente del Vendedor [%s] \n no esta registrado en la Tabla de Contribuyentes de RETEFUENTE, \n Vaya a la Tabla de Contribuyentes de Retefuente y registre dicho Tipo !!!')%(contribuyente_rete.browse(cr, uid, vendedor_rete).name))
        if comprador_vale_rete== False:
            raise osv.except_osv(_('Atencion !'), _('El tipo de Contribuyente del Comprador [%s] \n no esta registrado en la Tabla de Contribuyentes de REYEFUENTE, \n para el tipo de Vendedor [%s] de esta Factura \n Vaya a la Tabla de Contribuyentes Retefuente y registre dicho Tipo !!!')%(contribuyente_rete.browse(cr, uid, comprador_rete).name,contribuyente_rete.browse(cr, uid, vendedor_rete).name))     

        if res['aplica_rta'] == True: #se llama al metodo de retener rete
            self._retener_renta(cr, uid, ids,t_nat_jur_rete, tipo)
        else:
            inv.write({'status_rete':"tax_payer" })
   
        return True
    
   #Metodo que retiene el Impuesto de tipo Retefuente, si rete_bool=true y si se cumplen las otras validaciones
    def _retener_renta(self, cr, uid, ids,t_nat_jur_rete, tipo,context=None):
        print "metodo de retencion del rete"
        print "el tipo del vendedor es un"
        print t_nat_jur_rete
        invoices = self.browse(cr, uid, ids, context=None)
        uvt = self.pool.get('l10n.co.uvt')   
        for inv in invoices:
            if inv.procesado_rete=="no_pro": #si aun no se ha procesado la orden de retencion para rete    
                dict_ret = {}
                for line in inv.invoice_line:
                    #~ Agrupamos por concepto de retencion de renta
                    concepto_id = line.concept_retention_rete.id if line.concept_retention_rete else False
                    if not concepto_id:
                        nota = '''
                        El Producto [%s] 
                        no tiene un concepto para Retencion de Renta Definido en su ficha,
                        vaya a la ficha del mismo y asignele un Concepto de Retencion de Renta
                        '''%(line.product_id.name)
                        raise osv.except_osv(_('Atencion !'), _(nota))
                    #~ Acumulamos los elementos del mismo tipo de concepto en un diccionario
                    if not concepto_id in dict_ret.keys():          #Primera vez que aparece el concepto
                        dict_ret[concepto_id]=[line.price_subtotal,[line.id]]
                    else:                                           #Las otras veces en que aparece el concepto
                        dict_ret[concepto_id][0]+=line.price_subtotal
                        dict_ret[concepto_id][1].append(line.id)
                print 'DICCIONARIO DE CONCEPTOS, TOTALES, Y LISTA DE LINEAS, ',dict_ret
                # Ya a esta altura se sabe que tipo e agente es el comprador de la factura
                retenible = {} 
                item_obj = self.pool.get('baremo.rent.item')
                for key in dict_ret.keys():#key son los ids de los conceptos de retencion rete
                    print 'key: ', key
                    # se obtienen las tasas del concepto.
                    if t_nat_jur_rete=="Natural":
                        tasas = item_obj.browse(cr, uid, key, context).natural_ids
                    else: # Personal Juridica
                        tasas = item_obj.browse(cr, uid, key, context).juridico_ids
                    # Verificamos si estan las cuentas contables definidas en el concepto
                    if not item_obj.browse(cr, uid, key, context).retencion_venta:                            
                        nota = '''
                            El Concepto de Retencion en la Fuente
                            [%s][%s] 
                            no tiene cuenta contable definida para la Venta
                            '''%(item_obj.browse(cr, uid, key, context).categoria_id.name,item_obj.browse(cr, uid, key, context).name)
                        raise osv.except_osv(_('Atencion !'), _(nota))
                    if not item_obj.browse(cr, uid, key, context).retencion_compra:
                        nota = '''
                            El Concepto de Retencion en la Fuente
                            [%s][%s] 
                            no tiene cuenta contable definida para la Compra
                            '''%(item_obj.browse(cr, uid, key, context).categoria_id.name,item_obj.browse(cr, uid, key, context).name)
                        raise osv.except_osv(_('Atencion !'), _(nota))
                    if tasas:
                        for tasa in tasas:
                            print 'tasa: ', tasa.base
                            tasa_base = uvt.compute_uvt_to_money(cr, uid, tasa.base, inv.date_invoice, context)#metodo que transforma los UVT 
                            print "la tasa_base es (costo producto pasado en uvt): ",tasa_base
                            print " lo que tiene que superar es:", dict_ret[key][0] 
                            base_refund=tasa_base
                            tarifa_refund=tasa.tarifa
                            if dict_ret[key][0] >= tasa_base: #en el caso que sea 0>=0 entraria igual,, pero no hay facturas con lineas en 0
                                retenible[key]= [dict_ret[key][1], tasa_base, tasa.tarifa]
                                break
                        if inv.type=="out_refund" or inv.type=="in_refund": #no pregunta si supera las UVT estipuladas 
                            retenible[key]= [dict_ret[key][1], base_refund, tarifa_refund]
                        
                    else:
                        if t_nat_jur_rete=="Natural":
                            nota = '''
                            El Concepto de Retencion en la Fuente
                            [%s][%s] 
                            no tiene tasas de retencion definida para Personas Naturales
                            por favor dirijase al menu Baremo ReteFuente y asigne una tasa
                            '''%(item_obj.browse(cr, uid, key, context).categoria_id.name,item_obj.browse(cr, uid, key, context).name)
                            raise osv.except_osv(_('Atencion !'), _(nota))
                        else:
                            nota = '''
                            El Concepto de Retencion en la Fuente
                            [%s][%s] 
                            no tiene tasas de retencion definida para Personas Juridicas
                            por favor dirijase al menu Baremo ReteFuente y asigne una tasa
                            '''%(item_obj.browse(cr, uid, key, context).categoria_id.name,item_obj.browse(cr, uid, key, context).name)
                            raise osv.except_osv(_('Atencion !'), _(nota))

                if retenible:
                    print 'retenible: ',retenible
                    #~ Es el ultimo procedimiento que se hace
                    ################para las notas de credito################    
                    if inv.type=="out_refund" or inv.type=="in_refund" :#para notas de credito
                        if inv.parent_id and inv.parent_id.procesado_rete=="pro" : #si tiene factura padre y tiene retencion   
                            self.get_rete_refund(cr, uid, ids, inv,t_nat_jur_rete,retenible,tipo, context)
                        else:
                            raise osv.except_osv(_('Atencion !'), _('La Nota de Credito no tiene factura asociada o aun esta no ha sido \n retenida, no podra retener!!!'))
                    else: #para las facturas
                        retention_id=self.crear_retencion_rete(cr, uid, ids, inv.id, t_nat_jur_rete) #inv.id es el id de la cabecera de la factura
                        self.crear_retencion_rete_line(cr, uid, ids, retention_id, retenible, tipo, context=None)
                        inv.write({'procesado_rete':"pro"              ,
                                    'rete_rete_doc':retention_id       ,
                                    'status_rete':'cal'                ,
                                })
                else: #si no supera la tasa
                    inv.write({'status_rete':"tasa"})
        return True
    
    #metodo que genera la retencion para notas de credito
    def get_rete_refund(self, cr, uid, ids, inv,t_nat_jur_rete,retenible,tipo, context):
        retention_id=self.crear_retencion_rete(cr, uid, ids, inv.id, t_nat_jur_rete) #inv.id es el id de la cabecera de la factura
        retenible_refund={}
        rete_rete=self.pool.get('account.retention.rete')   
        rete_id = rete_rete.search(cr, uid, [('invoice_id','=',inv.parent_id.id)])[0]     
        rete_bw = rete_rete.browse(cr, uid, rete_id , context=None)
        line_rete=rete_bw.retention_line
        print "las lineas son: ",line_rete
        for line_papa in line_rete: #lineas de retencion del papa
            print "line_papa.baremo_rent_item_id.id",line_papa.baremo_rent_item_id.id
            if line_papa.baremo_rent_item_id.id in retenible.keys(): #si se retuvo el mismo concepto
                retenible_refund[line_papa.baremo_rent_item_id.id]= [ retenible[line_papa.baremo_rent_item_id.id][0], retenible[line_papa.baremo_rent_item_id.id][1], retenible[line_papa.baremo_rent_item_id.id][2] ]
        print "retenible para refund es: tiene",retenible                       
        self.crear_retencion_rete_line_refund(cr, uid, ids, retention_id, retenible_refund, tipo, context=None)
        inv.write({'procesado_rete':"pro"              ,
                                    'rete_rete_doc':retention_id       ,
                                    'status_rete':'cal'                ,
                                })
        return True
    
    #Metodo que crea la cabecera del documento de retencion para RETEFUENTE   
    def crear_retencion_rete(self, cr, uid, ids, inv_id,t_nat_jur_rete, context=None):
        print "entra al metodo de retencion rete"
        rete_rete=self.pool.get('account.retention.rete')
        inv = self.browse(cr, uid, inv_id, context=None)
        def _nombre(cr,uid, inv_id, context=None):
            rete_rete=self.pool.get('account.retention.rete')
            codigo=rete_rete._get_seq_code(cr, uid, context=None) #se llama al metodo para obtener el numero de secuencia del CODE
            if inv.type == 'in_invoice' or inv.type == 'in_refund': #si es una factura de compra
                nombre="RETENCION DE RETE %s DEL DOCUMENTO %s CODIGO: %s" %(inv.partner_id.name ,inv.reference, codigo)
            else: #si es una factura de venta
                nombre="RETENCION DE RETE %s DEL DOCUMENTO %s CODIGO: %s" %(inv.partner_id.name ,inv.number, codigo)
            return nombre
        #ENCABEZADO DE RETENCIONES
        retention_id=rete_rete.create(cr, uid,{
                                'period_id': None                       ,
                                'company_id': inv.company_id.id         ,
                                # 'code': None                          , se genera en el defaul de account.retention.rete
                                'invoice_id': inv.id                    ,
                                'type':inv.type                         ,
                                'account_id':inv.account_id.id          ,
                                'partner_id':inv.partner_id.id          ,
                                'currency_id':inv.currency_id.id        , 
                                #'journal_id':inv.journal_id.id         ,#toma el defaul para el diario de rete
                                'move_id':None                          ,
                                #'state':"draft"                        ,# toma el defaul del modelo
                                'date_ret':None                         ,
                                'date':time.strftime('%Y-%m-%d')        ,
                                'nat_jur':t_nat_jur_rete                ,
                                'name':_nombre(cr,uid, inv_id, context=None)                           ,                                                             
                                },context=None)    
        return retention_id
          
    def crear_retencion_rete_line(self, cr, uid, ids, retention_id, retenible, tipo, context=None):
        inv_line_obj = self.pool.get('account.invoice.line')
        rete_rete_line=self.pool.get('account.retention.rete.line')
        for key in retenible.keys():
            for line_id in retenible[key][0]:
                line = inv_line_obj.browse(cr, uid, line_id, context)
                
                cuenta_id = line.concept_retention_rete.retencion_compra.id if tipo == 'compra' else line.concept_retention_rete.retencion_venta.id
                
                rete_rete_line.create(cr, uid,{
                    'name':line.name                                             ,
                    'retention_id':retention_id                                  ,
                    'move_line_id': None                                         ,                    
                    'producto_id':line.product_id and line.product_id.id or False,                    
                    'invoice_line_id':line_id                                    ,
                    'subtotal':line.price_subtotal                               ,
                    'tarifa':retenible[key][2]                                   , 
                    'base':retenible[key][1]                                     ,
                    'monto_retener':line.price_subtotal*retenible[key][2]/100    ,
                    'account_id':cuenta_id                                       ,                                                             
                    'baremo_rent_item_id':key                                    ,                                                             
                            },context=None)
        return True
    
    def crear_retencion_rete_line_refund(self, cr, uid, ids, retention_id, retenible, tipo, context=None):
        inv_line_obj = self.pool.get('account.invoice.line')
        rete_rete_line=self.pool.get('account.retention.rete.line')
        for key in retenible.keys():
            for line_id in retenible[key][0]:
                line = inv_line_obj.browse(cr, uid, line_id, context)
                
                cuenta_id = line.concept_retention_rete.retencion_compra.id if tipo == 'compra' else line.concept_retention_rete.retencion_venta.id
                
                rete_rete_line.create(cr, uid,{
                    'name':line.name                                              ,
                    'retention_id':retention_id                                   ,
                    'move_line_id': None                                          ,                    
                    'producto_id':line.product_id and line.product_id.id or False ,                    
                    'invoice_line_id':line_id                                     ,
                    'subtotal':line.price_subtotal                                ,
                    'tarifa':retenible[key][2]                                    , 
                    'base':retenible[key][1]                                      ,
                    'monto_retener':-1*(line.price_subtotal*retenible[key][2]/100),
                    'account_id':cuenta_id                                        ,                                                             
                    'baremo_rent_item_id':key                                     ,                                                             
                            },context=None)
        return True

account_invoice()
