# -*- encoding: utf-8 -*-
###########################################################################
#    Module Writen to OpenERP, Open Source Management Solution
#    Copyright (C) OpenERP Venezuela (<http://openerp.com.ve>).
#    All Rights Reserved
###############Credits######################################################
#    Coded by: Angelica Barrios angelicaisabelb@gmail.com
#              Humberto Arocha humberto@openerp.com.ve
#    Planified by: Humberto Arocha
#    Finance by: LUBCAN COL S.A.S http://www.lubcancol.com
#    Audited by: Humberto Arocha humberto@openerp.com.ve
#############################################################################
#    This program is free software: you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation, either version 3 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program.  If not, see <http://www.gnu.org/licenses/>.
##############################################################################

import time
from report import report_sxw
from osv import osv
import pooler
from tools import config
import xml
import copy
from operator import itemgetter
import datetime




class rep_wizard(report_sxw.rml_parse):
        

    def __init__(self, cr, uid, name, context):
        super(rep_wizard, self).__init__(cr, uid, name, context)
        self.sum_debit = 0.00
        self.sum_credit = 0.00
        self.sum_balance = 0.00
        self.sum_debit_fy = 0.00
        self.sum_credit_fy = 0.00
        self.sum_balance_fy = 0.00
        self.date_lst = []
        self.date_lst_string = ''        
        self.query = ""    # SQL query to get account moves for given date or period
        self.min_date = "" # Min date of the given date or period
        self.ctx = {}      # Context for given date or period
        self.ctxfy = {}    # Context from the date start or first period of the fiscal year
        self.child_ids = ""
        self.tot_currency = 0.0
        self.balance_accounts = {}
        self.localcontext.update({
            'time': time,
            'get_partner':self._get_partner                             ,
            'get_retencion':self._get_retencion                         ,
            'name_partner':self._name_partner                           ,
            'get_dates':self._get_dates                                 ,
            'get_fecha_emi':self._get_fecha_emi                         ,
            'get_tipo':self._get_tipo                                   ,
            'get_invoice':self._get_invoice                             ,
            'get_type_invoice':self._get_type_invoice                   ,
            'get_vouchers':self._get_vouchers                           ,
            'get_type_vouchers':self._get_type_vouchers                 ,
            'get_stock':self._get_stock                                 ,
            'get_status_stock_invoice':self._get_status_stock_invoice   ,
            'lines': self.lines                                         ,
            'get_children_accounts': self.get_children_accounts         ,
            'lines_detalle':self.lines_detalle                          ,
            'sum_debit_account': self._sum_debit_account,
            'sum_credit_account': self._sum_credit_account,
            'sum_balance_account': self._sum_balance_account,
            'sum_currency_amount_account': self._sum_currency_amount_account,

        })
        self.context = context
    

    #para los partners  
    def _get_partner(self,form):
        part=form['partner_id']
        partners=part[0][2]
        print "lo que tiene los partner es:", partners
        res=[]
        if partners:#si hay filtro de partners
            res=partners
        else: #si no hay filtro de partners, se dan todos los partners
            part = self.pool.get('res.partner')
            res=part.search(self.cr,self.uid,[('id','<>',None)])
        print "parteners es: ",res
        return res
       
    
    #para las retenciones
    def _get_retencion(self,form, id_part, tipo):
        print "el partner_id es:", id_part
        bandera=0
        print" el tipo es: ", tipo
        periodo=form['fiscalyear_id']
        fiscalyear = self.pool.get('account.fiscalyear')
        year=fiscalyear.browse(self.cr, self.uid, periodo)
        if tipo=="iva":
            rete=self.pool.get('account.retention.iva')
        if tipo=="ica":
            rete=self.pool.get('account.retention.ica')
        if tipo=="rete":
            rete=self.pool.get('account.retention.rete')
        print "el periodo fiscal es:", year.name
        vector=[]
        data=[]        
        for i in year.period_ids: #para todos los periodos
            print "el periodo es: ", i.name
            retencion = rete.search(self.cr, self.uid, [('period_id', '=',i.id), ('partner_id', '=',id_part)])
            print "la retencion es: ", retencion
            if len(retencion)!=0: #si esta en un periodo
                vector.extend(retencion)
                bandera=1
        if bandera==1: #si hay periodo asociados a ese ano en el modelo de retencion, si no entra aqui se manda una excepcion
            data =rete.browse(self.cr,self.uid, vector) 
        else:
            data.append("")  
        print "lo que tiene data es:  ",  data        
        return data

    #nombre del partner
    def _name_partner(self,codigo):
        part = self.pool.get('res.partner')
        name=part.browse(self.cr, self.uid, codigo).name
        return name


    #para las facturas
    def _get_invoice(self,form,id_part):
        print "el partner_id es:", id_part
        bandera=0
        vector=[]
        data=[]
        clie=form['cliente']
        pro=form['proveedor']
        periodo=form['fiscalyear_id']
        fiscalyear = self.pool.get('account.fiscalyear')
        invoice = self.pool.get('account.invoice')
        year=fiscalyear.browse(self.cr, self.uid, periodo)     
        
        if pro==True:  #si se trata de una factura de COMPRA
            for i in year.period_ids: #para todos los periodos
                print "el periodo es: ", i.name
                inv = invoice.search(self.cr, self.uid, [('period_id', '=',i.id), ('type','=',"in_invoice"),('partner_id', '=',id_part)] )
                inv2 = invoice.search(self.cr, self.uid, [('period_id', '=',i.id), ('type','=',"in_refund"),('partner_id', '=',id_part)] )
                if len(inv)!=0: #si esta en un periodo
                    print inv
                    vector.extend(inv)
                    bandera=1
                if len(inv2)!=0: #si esta en un periodo
                    print inv2
                    vector.extend(inv2)
                    bandera=1 
        
        if clie==True: #si se trata de una factura de VENTA
            for i in year.period_ids: #para todos los periodos
                print "el periodo es: ", i.name
                inv = invoice.search(self.cr, self.uid, [('period_id', '=',i.id), ('type','=',"out_invoice"),('partner_id', '=',id_part)] )
                inv2 = invoice.search(self.cr, self.uid, [('period_id', '=',i.id), ('type','=',"out_refund"),('partner_id', '=',id_part)] )
                if len(inv)!=0: #si esta en un periodo
                    print inv
                    vector.extend(inv)
                    bandera=1
                if len(inv2)!=0: #si esta en un periodo
                    print inv2
                    vector.extend(inv2)
                    bandera=1
                          
        if bandera==1: #si hay periodo asociados a ese ano en el modelo de retencion, si no entra aqui se manda una excepcion
            data = invoice.browse(self.cr,self.uid, vector)
        else:
            data.append("")      
        return data
    
    #para el tipo de la factura
    def _get_type_invoice (self, form):
        clie=form['cliente']
        pro=form['proveedor']
        if clie==True:
            tipo="Factura de Venta"
        if pro==True:  
            tipo="Factura de Compra"    
        return tipo
    

    #periodo fiscal
    def _get_dates(self, form):
        res=[]
        periodo=form['fiscalyear_id']
        fiscalyear = self.pool.get('account.fiscalyear')
        year=fiscalyear.browse(self.cr, self.uid, periodo)
        ano=year.name
        res.append(ano)
        res.append("hola")
        return ano

    def _get_fecha_emi(self,form):
        res=[]
        res.append(time.strftime('%Y-%m-%d') )     
        return res

    
    def _get_tipo(self, vat=''):
        print vat
        if vat == 'in_invoice' or vat == 'in_refund':
            res="Compra"
        elif vat == 'out_invoice' or vat == 'out_refund':
            res="Venta"  
        if not vat:
            res=""
        return res
    
    
    #para las lineas del vouchers que tengan al partner y el periodo fiscal
    def _get_vouchers(self,form,id_part):
        print" Entro en el metodo del vouchers"
        print "el partner_id es:", id_part
        periodo=form['fiscalyear_id']
        fiscalyear = self.pool.get('account.fiscalyear')
        linea = self.pool.get('account.voucher.line')
        voucher = self.pool.get('account.voucher')
        year=fiscalyear.browse(self.cr, self.uid, periodo)
        bandera=0
        vector=[]
        data=[]
        for i in year.period_ids: #para todos los periodos
            print "el periodo es: ", i.name
            vou = voucher.search(self.cr, self.uid, [('period_id', '=',i.id), ('state','=',"proforma")] )
            if len(vou)!=0: #si existe un voucher que este en el periodo
                for j in vou:
                    lin = linea.search(self.cr, self.uid, [('partner_id', '=',id_part), ('voucher_id','=',j)] )
                    if len(lin)!=0:
                        print lin
                        vector.extend(lin)
                        bandera=1
        if bandera==1: #si hay periodo asociados 
            data = linea.browse(self.cr,self.uid, vector) 
        else:
            data.append("")  
        return data
    
    
    #Tipo de vouchers
    def _get_type_vouchers(self,vat=''):
        print vat
        if vat == 'dr':
            res="Debito"
        elif vat == 'cr':
            res="Credito"  
        if not vat:
            res=""
        return res

    
    #para las lineas del Stock que tengan el partner y el periodo fiscal
    def _get_stock(self,form, id_part):
        print" Entro en el metodo del stock"
        print "el partner_id es:", id_part
        periodo=form['fiscalyear_id']
        fiscalyear = self.pool.get('account.fiscalyear')
        part = self.pool.get('res.partner')
        stock = self.pool.get('stock.picking')
        linea = self.pool.get('stock.move')
        year=fiscalyear.browse(self.cr, self.uid, periodo)
        partner=part.browse(self.cr, self.uid, id_part)
        bandera=0
        vector=[]
        data=[]
        for address in partner.address:
            sto = stock.search(self.cr, self.uid, [ ('state','=',"done")                      , 
                                                    ('date_done' , '>=', year.date_start)     ,
                                                    ('date_done', '<=',year.date_stop )       ,
                                                    ('address_id','=',address.id)             ,
                                                    ])
            if len(sto)!=0: #si esta en un periodo
                for i in sto:
                    lin = linea.search(self.cr, self.uid, [('picking_id','=',i)] )
                    if len(lin)!=0:
                        print lin
                        vector.extend(lin)
                        bandera=1
        if bandera==1: #si hay periodo asociados 
            data = linea.browse(self.cr,self.uid, vector) 
        else:
            data.append("")
        return data



    #Tipo de de status de la factura para el stock: politica de factura
    def _get_status_stock_invoice(self,vat=''):
        print vat
        if vat == 'invoiced':
            res="Facturado"
        if vat == '2binvoiced':
            res="Por Facturar"
        if vat == 'none':
            res="Not from Packing"   
        if not vat:
            res=""
        return res
    

########################metodo resumen contable (mayor analitico de la cuenta y balance)###############################################
    def lines(self, form,id_part, ids={}, done=None, level=0):
        bandera=False
        print "entro al metodo de lineas"
        print "el partner_id es:", id_part
        clie=form['cliente']
        pro=form['proveedor']
        account_ids=[]
        lista=[]
        lista2=[]
        user=form['user_id']
        print "lo que tiene user es", user
        print "lo que tiene form es:", form
        
        #se buscan las cuentas del partner
        part = self.pool.get('res.partner') 
        
        if user:#si hay filtro de user  
            lista = part.search(self.cr,self.uid,[('user_id','=',user),('id','=',id_part)])
            for j in lista:
                partner=part.browse(self.cr, self.uid, j)
                if pro== True: #Cuentas por Cobrar: Account Receivable
                    cuenta=partner.property_account_receivable.id
                    account_ids.append(cuenta)
                    print "la cuenta es ", partner.property_account_receivable.name
        
                if clie==True: #Cuentas por Pagar: Account Payable
                    cuenta=partner.property_account_payable.id
                    account_ids.append(cuenta)
                    print "la cuenta es ", partner.property_account_payable.name
                
        else:#si no hay filtro de user
            partner=part.browse(self.cr, self.uid, id_part)
            if pro== True: #Cuentas por Cobrar: Account Receivable
                cuenta=partner.property_account_receivable.id
                account_ids.append(cuenta)
                print "la cuenta es ", partner.property_account_receivable.name
    
            if clie==True: #Cuentas por Pagar: Account Payable
                cuenta=partner.property_account_payable.id
                account_ids.append(cuenta)
                print "la cuenta es ", partner.property_account_payable.name                 
        if not ids:
            ids = self.ids
        if not ids:
            return []
        if not done:
            done = {}          
        res = {}
        result_acc = []
        accounts_levels = {}
        account_obj = self.pool.get('account.account')
        period_obj = self.pool.get('account.period')
        fiscalyear_obj = self.pool.get('account.fiscalyear')

        # Get the fiscal year
        fiscalyear = None
        if form.get('fiscalyear_id'):
            fiscalyear = fiscalyear_obj.browse(self.cr, self.uid, form['fiscalyear_id'])
        else:
            fiscalyear = fiscalyear_obj.browse(self.cr, self.uid, fiscalyear_obj.find(self.cr, self.uid))
        #
        # Get the accounts
        #
        child_ids = account_obj._get_children_and_consol(self.cr, self.uid, account_ids, self.context)
        if child_ids:
            account_ids = child_ids
        
        print "lo que tiene account_ids es: ",account_ids           
        #
        # Calculate the FY Balance.
        # (from full fiscal year without closing periods)
        #
        ctx = self.context.copy()
        if form.get('fiscalyear_id'):
            # Use only the current fiscal year
            ctx['fiscalyear_id'] = fiscalyear.id
            ctx['mes'] = period_obj.search(self.cr, self.uid, [('fiscalyear_id','=',fiscalyear.id),'|',('special','=',False),('date_stop','<',fiscalyear.date_stop)])
        else:
            # Use all the open fiscal years
            open_fiscalyear_ids = fiscalyear_obj.search(self.cr, self.uid, [('state','=','draft')])
            ctx['mes'] = period_obj.search(self.cr, self.uid, [('fiscalyear_id','in',open_fiscalyear_ids),'|',('special','=',False),('date_stop','<',fiscalyear.date_stop)])

        fy_balance = {}
        for acc in account_obj.read(self.cr, self.uid, account_ids, ['balance'], ctx):
            fy_balance[acc['id']] = acc['balance']
        
        print "lo que tiene fy_balance es: ", fy_balance

        #
        # Calculate the FY Debit/Credit
        # (from full fiscal year without opening or closing periods)
        #
        ctx = self.context.copy()
        ctx['fiscalyear_id'] = fiscalyear.id
        ctx['mes'] = period_obj.search(self.cr, self.uid, [('fiscalyear_id','=',fiscalyear.id),('special','=',False)])

        fy_debit = {}
        fy_credit = {}
        for acc in account_obj.read(self.cr, self.uid, account_ids, ['debit','credit','balance'], ctx):
            fy_debit[acc['id']] = acc['debit']
            fy_credit[acc['id']] = acc['credit']
        
        print "lo que tiene fy_debit es: ", fy_debit
        print "lo que tiene fy_credit es: ", fy_credit

        #
        # Calculate the period Debit/Credit
        # (from the selected period or all the non special periods in the fy)
        #
        # esto es lo que tiene      'context': {'lang': u'en_US', 'client': u'web', 'tz': False},
        ctx = self.context.copy()
        #ctx['state'] = form['context'].get('state','all')
        ctx['fiscalyear_id'] = fiscalyear.id
        ctx['mes'] = period_obj.search(self.cr, self.uid, [('fiscalyear_id','=',fiscalyear.id),('special','=',False)])
        ctx['mes'] = form['mes']

        accounts = account_obj.read(self.cr, self.uid, account_ids, ['type','code','name','debit','credit','balance','parent_id'], ctx)
        print "lo que tiene  accounts es: ", accounts
        #
        # Calculate the period initial Balance
        # (fy balance minus the balance from the start of the selected period
        #  to the end of the year)
        #
        ctx = self.context.copy()
        ctx['fiscalyear_id'] = fiscalyear.id
        ctx['mes'] = period_obj.search(self.cr, self.uid, [('fiscalyear_id','=',fiscalyear.id),('special','=',False)])
        ctx['mes'] = form['mes']
        date_start=period_obj.browse(self.cr, self.uid, ctx['mes']).date_start
        ctx['mes'] = period_obj.search(self.cr, self.uid, [('fiscalyear_id','=',fiscalyear.id),('date_start','>=',date_start),('special','=',False)])
        period_balanceinit = {}
        for acc in account_obj.read(self.cr, self.uid, account_ids, ['balance'], ctx):
            period_balanceinit[acc['id']] = fy_balance[acc['id']] - acc['balance']
        print "lo que tiene period_balanceinit es: ", period_balanceinit
        #
        # Generate the report lines (checking each account)
        #
        for account in accounts:
            account_id = account['id']

            if account_id in done:
                continue

            done[account_id] = 1
            #
            # Calculate the account level
            #
            parent_id = account['parent_id']
            if parent_id:
                if isinstance(parent_id, tuple):
                    parent_id = parent_id[0]
                account_level = accounts_levels.get(parent_id, 0) + 1
            else:
                account_level = level
            accounts_levels[account_id] = account_level
            
            res = {
                    'id' : account_id,
                    'type' : account['type'],
                    'code': account['code'],
                    'name': account['name'],
                    'level': account_level,
                    'balanceinit': period_balanceinit[account_id],
                    'debit': account['debit'],
                    'credit': account['credit'],
                    'balance': period_balanceinit[account_id]+account['balance'],
                    'balanceinit_fy': fy_balance[account_id]-fy_debit[account_id]+fy_credit[account_id],
                    'debit_fy': fy_debit[account_id],
                    'credit_fy': fy_credit[account_id],
                    'balance_fy': fy_balance[account_id],
                    'parent_id': account['parent_id'],
                    'bal_type': '',
                }
            #
            # Round the values to zero if needed (-0.000001 ~= 0)
            #
            if abs(res['balance']) < 0.5 * 10**-int(config['price_accuracy']):
                res['balance'] = 0.0
            if abs(res['balance_fy']) < 0.5 * 10**-int(config['price_accuracy']):
                res['balance_fy'] = 0.0
            if abs(res['balanceinit']) < 0.5 * 10**-int(config['price_accuracy']):
                res['balanceinit'] = 0.0
            if abs(res['balanceinit_fy']) < 0.5 * 10**-int(config['price_accuracy']):
                res['balanceinit_fy'] = 0.0

            # Include all accounts
            result_acc.append(res)
            bandera=True
        
        if bandera==False: #si tiene algo
            dic={'code':' '         ,
                 'name':' '         ,
                 'balanceinit':' '  ,
                 'debit':' '        , 
                 'credit':' '       ,
                 'balance': ' '     ,
                 }
            result_acc.append(dic)
                              
        return result_acc
   
   
   
       ##################metodos para el resumen detallado contable#####################################
       
    def get_children_accounts(self,id_part, form):
        print "entro en el metodo get_children_accounts "
        move_line_obj = self.pool.get('account.move.line')
        account_obj = self.pool.get('account.account')
        invoice_obj = self.pool.get('account.invoice')
        self.child_ids = account_obj.search(self.cr, self.uid, [('parent_id', 'child_of', self.ids)])
               
        account_ids=[] #lista de objetos cuentas del partner
        lista=[]
        lista2=[]
        user=form['user_id']
        clie=form['cliente']
        pro=form['proveedor']
        ids_acc=[]
        print "entro al metodo get_children_accounts"
        print "el partner_id es:", id_part
        
        #se busca la cuenta del partner
        part = self.pool.get('res.partner')     
        if user:#si hay filtro de user  
            lista = part.search(self.cr,self.uid,[('user_id','=',user),('id','=',id_part)])
            for j in lista:
                partner=part.browse(self.cr, self.uid, j)
                if pro== True: #Cuentas por Cobrar: Account Receivable
                    cuenta=partner.property_account_receivable
                    account_ids.append(cuenta)
                    print "la cuenta es ", partner.property_account_receivable.name
        
                if clie==True: #Cuentas por Pagar: Account Payable
                    cuenta=partner.property_account_payable
                    account_ids.append(cuenta)
                    print "la cuenta es ", partner.property_account_payable.name
                
        else:#si no hay filtro de user
            partner=part.browse(self.cr, self.uid, id_part)
            if pro== True: #Cuentas por Cobrar: Account Receivable
                cuenta=partner.property_account_receivable
                account_ids.append(cuenta)
                print "la cuenta es ", partner.property_account_receivable.name
    
            if clie==True: #Cuentas por Pagar: Account Payable
                cuenta=partner.property_account_payable
                account_ids.append(cuenta)
                print "la cuenta es ", partner.property_account_payable.name  

        res = []
        ctx = self.ctx.copy()

        # ctx: Context for the given date or period
        if 'fiscalyear_id' in form and form['fiscalyear_id']:
            ctx['fiscalyear_id'] = form['fiscalyear_id']
        if 'mes' in form and form['mes']:
            ctx['mes'] = form['mes']        
        self.ctx = ctx
        self.query = self.pool.get('account.move.line')._query_get(self.cr, self.uid, context=ctx)
        
        print "lo que tiene accound_ids es:", account_ids
        for account in account_ids:
            try:
                if account and account.child_consol_ids: # add ids of consolidated childs also of selected account
                    ctx['consolidate_childs'] = True
                    ctx['account_id'] = account.id
                ids_acc = account_obj.search(self.cr, self.uid,[('parent_id', 'child_of', [account.id])], context=ctx) 
            except:
                ids_acc=[] 
            
            for child_id in ids_acc:
                child_account = account_obj.browse(self.cr, self.uid, child_id)
                balance_account = self._sum_balance_account(child_account,form)
                self.balance_accounts[child_account.id] = balance_account
                if child_account.type != 'view' \
                and len(move_line_obj.search(self.cr, self.uid,
                    [('account_id','=',child_account.id)],
                    context=ctx)) <> 0 :
                    res.append(child_account)                    
                else:
                    if child_account.type != 'view' \
                    and len(move_line_obj.search(self.cr, self.uid,
                        [('account_id','>=',child_account.id)],
                        context=ctx)) <> 0 :
                        res.append(child_account)
            
            print "lo que tiene res es: ", res
            if not len(res): #cuando no tiene nada res
                print "se metio por acaaaa y va a retornar accound: ", account.name
                return [account] #retorna la cuenta
            else:
                ## We will now compute initial balance
                for move in res:
                    print "res esta lleno y se metio por aca"
                    sql_balance_init = "SELECT sum(l.debit) AS sum_debit, sum(l.credit) AS sum_credit "\
                        "FROM account_move_line l "\
                        "WHERE l.account_id = " + str(move.id) +  " AND %s" % (self.query)
                        
                                
                    self.cr.execute(sql_balance_init)
                    resultat = self.cr.dictfetchall()
                    if resultat[0] :
                        if resultat[0]['sum_debit'] == None:
                            sum_debit = 0
                        else:
                            sum_debit = resultat[0]['sum_debit']
                        if resultat[0]['sum_credit'] == None:
                            sum_credit = 0
                        else:
                            sum_credit = resultat[0]['sum_credit']

                        move.init_credit = sum_credit
                        move.init_debit = sum_debit
                    else:
                        move.init_credit = 0
                        move.init_debit = 0
        print "lo que arroja  get_children_accounts es",  res
        return res 
      
    
    def _sum_balance_account(self, account, form):
        # Balance from init fiscal year to last date given by the user
        accounts = self.pool.get('account.account').read(self.cr, self.uid, [account.id], ['balance'], self.ctxfy)
        sum_balance = accounts[0]['balance']
        return sum_balance
     

    def lines_detalle(self, account, form):
        print "entro al metodo de lines para el metodo detallado"
        print "lo que tiene account es: ", account
        inv_types = {
                'out_invoice':'CI: ',
                'in_invoice': 'SI: ',
                'out_refund': 'OR: ',
                'in_refund':  'SR: ',
                }

        sorttag = 'l.date'

        sql = """
            SELECT l.id, l.date, j.code, c.code AS currency_code, l.amount_currency, l.ref, l.name , l.debit, l.credit, l.period_id
                    FROM account_move_line as l
                       LEFT JOIN res_currency c on (l.currency_id=c.id)
                          JOIN account_journal j on (l.journal_id=j.id)
                             AND account_id = %%s
                             AND %s
                               ORDER by %s""" % (self.query, sorttag)
        self.cr.execute(sql % account.id)

        res = self.cr.dictfetchall()
        move_line_obj = self.pool.get('account.move.line')
        account_obj = self.pool.get('account.account')
        invoice_obj = self.pool.get('account.invoice')

        # Balance from init fiscal year to last date given by the user
        accounts = account_obj.read(self.cr, self.uid, [account.id], ['balance'], self.ctxfy)
        sum = accounts[0]['balance']

        for l in reversed(res):
            line = move_line_obj.browse(self.cr, self.uid, l['id'])
            l['move'] = line.move_id.name
            self.cr.execute('Select id from account_invoice where move_id =%s'%(line.move_id.id))
            tmpres = self.cr.dictfetchall()
            if len(tmpres) > 0 :
                inv = invoice_obj.browse(self.cr, self.uid, tmpres[0]['id'])
                l['ref'] = inv_types[inv.type] + ': '+str(inv.number)
            if line.partner_id :
                l['partner'] = line.partner_id.name
            else :
                l['partner'] = ''
            l['line_corresp'] = self._calc_contrepartie(self.cr,self.uid,[l['id']])[l['id']]

            # Cumulative balance update
            l['progress'] = sum
            sum = sum - l['debit'] + l ['credit']

            # Modification of currency amount
            if (l['credit'] > 0):
                if l['amount_currency'] != None:
                    l['amount_currency'] = abs(l['amount_currency']) * -1
            if l['amount_currency'] != None:
                self.tot_currency = self.tot_currency + l['amount_currency']

        if abs(sum) > 10**-int(config['price_accuracy']) and form['initial_balance']:
            res.insert(0, {
                'date': self.min_date,
                'name': _('Initial balance'),
                'progress': sum,
                'partner': '',
                'move': '',
                'ref': '',
                'debit': '',
                'credit': '',
                'amount_currency': '',
                'currency_code': '',
                'code': '',
                'line_corresp': '',
            })
        return res    
            

    def _calc_contrepartie(self, cr, uid, ids, context={}):
        result = {}
        #for id in ids:
        #    result.setdefault(id, False)

        for account_line in self.pool.get('account.move.line').browse(cr, uid, ids, context):
            # For avoid long text in the field we will limit it to 5 lines
            #
            result[account_line.id] = ' '
            num_id_move = str(account_line.move_id.id)
            num_id_line = str(account_line.id)
            account_id = str(account_line.account_id.id)
            # search the basic account
            # We have the account ID we will search all account move line from now until this time
            # We are in the case of we are on the top of the account move Line
            cr.execute("SELECT distinct(ac.code) as code_rest,ac.name as name_rest "\
                "FROM account_account AS ac, account_move_line mv "\
                "WHERE ac.id = mv.account_id and mv.move_id = " + num_id_move + " and mv.account_id <> " + account_id )
            res_mv = cr.dictfetchall()
            # we need a result more than 2 line to make the test so we will made the the on 1 because we have exclude the current line
            if (len(res_mv) >=1):
                concat = ''
                rup_id = 0
                for move_rest in res_mv:
                    concat = concat + move_rest['code_rest'] + '|'
                    result[account_line.id] = concat
                    if rup_id >5:
                        # we need to stop the computing and to escape but before we will add "..."
                        result[account_line.id] = concat + '...'
                        break
                    rup_id+=1
        return result


    def _sum_debit_account(self, account, form):
        self.cr.execute("SELECT sum(debit) "\
                "FROM account_move_line l "\
                "WHERE l.account_id = %s AND %s " % (account.id, self.query))
        sum_debit = self.cr.fetchone()[0] or 0.0
        return sum_debit

    def _sum_credit_account(self, account, form):
        self.cr.execute("SELECT sum(credit) "\
                "FROM account_move_line l "\
                "WHERE l.account_id = %s AND %s " % (account.id, self.query))
        sum_credit = self.cr.fetchone()[0] or 0.0
        return sum_credit
    
    def _set_get_account_currency_code(self, account_id):
        self.cr.execute("SELECT c.code as code "\
                "FROM res_currency c, account_account as ac "\
                "WHERE ac.id = %s AND ac.currency_id = c.id" % (account_id))
        result = self.cr.fetchone()
        if result:
            self.account_currency = result[0]
        else:
            self.account_currency = False
    
    def _sum_currency_amount_account(self, account, form):
        self._set_get_account_currency_code(account.id)
        self.cr.execute("SELECT sum(l.amount_currency) "\
                "FROM account_move_line as l, res_currency as rc "\
                "WHERE l.currency_id = rc.id AND l.account_id= %s AND %s" % (account.id, self.query))
        total = self.cr.fetchone()
        if self.account_currency:
            return_field = str(total[0]) + self.account_currency
            return return_field
        else:
            currency_total = self.tot_currency = 0.0
            return currency_total


report_sxw.report_sxw(
    'report.reporte.wizard.general'                                 ,
    'transaction.report'                                            ,
    'addons/l10n_co_transaction_report/report/reporte_wizard.rml'   ,
    parser=rep_wizard                                               ,
)      
