# -*- encoding: utf-8 -*-
###########################################################################
#    Module Writen to OpenERP, Open Source Management Solution
#    Copyright (C) OpenERP Venezuela (<http://openerp.com.ve>).
#    All Rights Reserved
###############Credits######################################################
#    Coded by: Angelica Barrios angelicaisabelb@gmail.com
#              Humberto Arocha humberto@openerp.com.ve
#    Planified by: Humberto Arocha
#    Finance by: LUBCAN COL S.A.S http://www.lubcancol.com
#    Audited by: Humberto Arocha humberto@openerp.com.ve
#############################################################################
#    This program is free software: you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation, either version 3 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program.  If not, see <http://www.gnu.org/licenses/>.
##############################################################################

import wizard
import osv
import pooler
import time

_transaction_form = '''<?xml version="1.0"?>
<form string=" Seleccione el periodo fiscal">
<group colspan='6' col='4'>
     <field name="fiscalyear_id"/>
     <field name="mes"/>
     <field name="user_id"/>
     <field name="partner_id" nolabel='1' colspan='6' widget="many2many"/>
     </group>
     <group>
     <group>
        <group attrs="{'invisible':[('proveedor','=','True')]}" >
            <group attrs="{'invisible':[('cliente','=','False')]}" >
                <field name="cliente"/>
            </group>   
        </group>

        <group attrs="{'invisible':[('cliente','=','True')]}" >
            <group attrs="{'invisible':[('proveedor','=','False')]}" >
                <field name="proveedor"/>
            </group>
        </group>
    </group>
    
    <hpaned>
    </hpaned>
    
    </group>

     

</form>'''

_transaction_fields = {
    'fiscalyear_id': {
        'string': 'Periodo Fiscal'          ,
        'type': 'many2one'                  ,
        'relation': 'account.fiscalyear'    ,
        'required': True                    ,
      },
      
    'mes': {
        'string': 'Mes Fiscal'              ,
        'type': 'many2one'                  ,
        'relation': 'account.period'        ,
        'required': True                    ,
      },
      
    'cliente': {
        'string': 'Cliente'                ,
        'type': 'boolean'                  ,
        'required': False                  ,
      },
      
    'proveedor': {
        'string': 'Proveedor'              ,
        'type': 'boolean'                  ,
        'required': False                  ,
      },
     
    'user_id': {
        'string': 'Salesman'                ,
        'type': 'many2one'                  ,
        'relation': 'res.users'             ,
        'required': False                   ,
       },     

    'partner_id': {
        'string': 'Partner'                 ,
        'type': 'many2one'                  ,
        'relation': 'res.partner'           ,
        'required': False                   ,                    
       },
}

class wizard_report (wizard.interface):

    def _check_tipo(self, cr, uid, data, context):
        bandera=False
        if data['form']['cliente'] == True:
            bandera=True
        if data['form']['proveedor'] == True:
            bandera=True
        if data['form']['user_id']== False:
            if not data['form']['partner_id']:
                bandera2=False                
        if bandera==False: #no selecciono nada
            raise wizard.except_wizard(('Error'), ('Debe Seleccionar el tipo de partner'))           
        return {}
    

    states = {
        'init': {
            'actions': [],
            'result': {'type': 'form'              , 
                       'arch':_transaction_form    ,  
                       'fields':_transaction_fields, 
                       'state':[('end','Cancel'),('print_report','Ver Reporte')]}
        },
        
         'print_report' : {
         'actions' : [_check_tipo]                      ,
         'result' : {'type' : 'print'                   ,
                     'report':'reporte.wizard.general'  ,
                     'state' : 'end'}
        }, 
    }

wizard_report ('tranc.report.xml')






