# -*- encoding: utf-8 -*-
###########################################################################
#    Module Writen to OpenERP, Open Source Management Solution
#    Copyright (C) OpenERP Venezuela (<http://openerp.com.ve>).
#    All Rights Reserved
###############Credits######################################################
#    Coded by: Angelica Barrios angelicaisabelb@gmail.com
#              Humberto Arocha humberto@openerp.com.ve
#    Planified by: Humberto Arocha
#    Finance by: LUBCAN COL S.A.S http://www.lubcancol.com
#    Audited by: Humberto Arocha humberto@openerp.com.ve
#############################################################################
#    This program is free software: you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation, either version 3 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program.  If not, see <http://www.gnu.org/licenses/>.
##############################################################################
from osv import osv
from osv import fields
from tools import config
from tools.translate import _
import time

class l10n_co_uvt(osv.osv):
    """
    OpenERP Model : l10n_co_uvt
    """
    
    _name = 'l10n.co.uvt'
    _description = __doc__
    _order = 'date desc'
    
    _columns = {
        'name':fields.char('Referencia Legal', size=64, required=True, readonly=False),
        'date': fields.date('Fecha de Vigencia', required=True),
        'amount': fields.float('Monto ($)', digits=(16, int(config['price_accuracy'])), help="Monto en Pesos ($) por UVT.", required=True),
    }
    _defaults = {
        'name': lambda *a: None,
    }


    def get_amount_uvt(self, cr, uid, date=False, *args):
        rate = 0
        date= date or time.strftime('%Y-%m-%d') 
        cr.execute("SELECT amount FROM l10n_co_uvt WHERE date <= '%s' ORDER BY date desc LIMIT 1" % (date))
        if cr.rowcount:
            rate=cr.fetchall()[0][0]
        return rate

    def compute_money_to_uvt(self, cr, uid, money, date=False, context={}):
        res_uvt = 0.0
        uvt = self.get_amount_uvt(cr, uid, date)
        if uvt:
            res_uvt = from_amount / uvt

        return res_uvt

    def compute_uvt_to_money(self, cr, uid, amount_uvt, date=False, context={}):
        money = 0.0
        uvt = self.get_amount_uvt(cr, uid, date)
        if uvt:
            money = amount_uvt * uvt
            if money <= 100:
                money = round(money,0)
            elif money > 100 and money <= 10000:
                money = round(money/100.0,0)*100
            else:
                money = round(money/1000.0,0)*1000
        return money
    
l10n_co_uvt()
