# -*- encoding: utf-8 -*-
###########################################################################
#    Module Writen to OpenERP, Open Source Management Solution
#    Copyright (C) OpenERP Venezuela (<http://openerp.com.ve>).
#    All Rights Reserved
###############Credits######################################################
#    Coded by: Angelica Barrios angelicaisabelb@gmail.com
#              Humberto Arocha humberto@openerp.com.ve
#    Planified by: Humberto Arocha
#    Finance by: LUBCAN COL S.A.S http://www.lubcancol.com
#    Audited by: Humberto Arocha humberto@openerp.com.ve
#############################################################################
#    This program is free software: you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation, either version 3 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program.  If not, see <http://www.gnu.org/licenses/>.
##############################################################################

import time
from report import report_sxw

class purchase_ingelub(report_sxw.rml_parse):
    def __init__(self, cr, uid, name, context):
        super(purchase_ingelub, self).__init__(cr, uid, name, context=context)
        self.localcontext.update({
            'time': time,
            'get_company_addr': self._get_company_addr,
            'get_partner_addr': self._get_partner_addr,
            'get_alicuota': self._get_alicuota
        })


    def _get_company_addr(self):
        company_obj = self.pool.get('res.company')
        company_ids = company_obj.search(self.cr,self.uid,[])
        company = company_obj.browse(self.cr, self.uid, company_ids[0])
        print "el nombre del partner es: ",company.partner_id.name
        addr_com = self._get_partner_addr(company.partner_id.id)
        print "addr_com",addr_com
        return addr_com


    #metodo que retorna la direccion fiscal si es de tipo invoice o de tipo delivery
    def _get_partner_addr(self, idp=None):
        if not idp:
            return []
        addr_obj = self.pool.get('res.partner.address')
        res = 'NO HAY DIRECCION FISCAL DEFINIDA'
        addr_ids = addr_obj.search(self.cr,self.uid,[('partner_id','=',idp), ('type','=','invoice')])
        addr_ids2 = addr_obj.search(self.cr,self.uid,[('partner_id','=',idp), ('type','=','delivery')])
        addr_inv={}
        lista=""

        if addr_ids: #si es de tipo invoice la direccion              
            addr = addr_obj.browse(self.cr,self.uid, addr_ids[0])
            addr_inv['invoice'] = (addr.street and addr.street.title() or '')+' '+(addr.street2 and addr.street2.title() or '')+' '+(addr.zip or '')+ ' '+(addr.city and addr.city.title() or '')+ ' '+ (addr.country_id and addr.country_id.name.title() or '')+ ', Telf.:'+(addr.phone or '')+ ', Fax.:'+(addr.fax or '')
            lista=(addr.street and addr.street.title() or '')+' '+(addr.street2 and addr.street2.title() or '')+' '+(addr.zip or '')+ ' '+(addr.city and addr.city.title() or '')+ ' '+ (addr.country_id and addr.country_id.name.title() or '')+ ', Telf.:'+(addr.phone or '')+ ', Fax.:'+(addr.fax or '')
            
        if addr_ids2:#si es de tipo delivery la direccion 
            addr = addr_obj.browse(self.cr,self.uid, addr_ids2[0])
            addr_inv['delivery'] = (addr.street and addr.street.title() or '')+' '+(addr.street2 and addr.street2.title() or '')+' '+(addr.zip or '')+ ' '+(addr.city and addr.city.title() or '')+ ' '+ (addr.country_id and addr.country_id.name.title() or '')+ ', Telf.:'+(addr.phone or '')+ ', Fax.:'+(addr.fax or '')
            lista=(addr.street and addr.street.title() or '')+' '+(addr.street2 and addr.street2.title() or '')+' '+(addr.zip or '')+ ' '+(addr.city and addr.city.title() or '')+ ' '+ (addr.country_id and addr.country_id.name.title() or '')+ ', Telf.:'+(addr.phone or '')+ ', Fax.:'+(addr.fax or '')
                      
            
        if addr_inv:
            #respuesta=addr_inv
            respuesta=lista
        else:
            respuesta=res
        return respuesta          
            


    def _get_alicuota(self, line=None):
        if not line:
            return []

        for taxes in line:
            tnom = taxes.name
            tax_obj = self.pool.get('account.tax')
            tax_ids = tax_obj.search(self.cr,self.uid,[('name','=',tnom)])[0]
            tax = tax_obj.browse(self.cr,self.uid, tax_ids)

        return tax.amount*100


report_sxw.report_sxw(
    'report.purchase.order.colombia',
    'purchase.order',
    'addons/purchase_report/report/order_colombia.rml',
    parser=purchase_ingelub,
    header = False 
)
# vim:expandtab:smartindent:tabstop=4:softtabstop=4:shiftwidth=4:
