#!/usr/bin/python
# -*- encoding: utf-8 -*-
###########################################################################
#    Module Writen to OpenERP, Open Source Management Solution
#    Copyright (C) OpenERP Venezuela (<http://openerp.com.ve>).
#    All Rights Reserved
###############Credits######################################################
#    Coded by: Angelica Barrios angelicaisabelb@gmail.com
#              Humberto Arocha humberto@openerp.com.ve
#    Planified by: Humberto Arocha
#    Finance by: LUBCAN COL S.A.S http://www.lubcancol.com
#    Audited by: Humberto Arocha humberto@openerp.com.ve
#############################################################################
#    This program is free software: you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation, either version 3 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program.  If not, see <http://www.gnu.org/licenses/>.
##############################################################################

from report import report_sxw
import pooler
from lxml import etree
import subprocess
import os
import StringIO
import cStringIO
import base64
import copy
import locale
import mx.DateTime
import re
import time
import ir
import netsvc
import osv
import tools
import warnings
import zipfile


def checkBins(*bin):
    bins = list(bin)
        
    searchPaths = os.environ["PATH"].split(":")
    for path in searchPaths:
        for bin in bins:
            if os.path.exists(os.path.join(path, bin)):
                bins.remove(bin)
        if bins == []: return
    raise IOError, "required binaries not %s found" % ", ".join(bins)

checkBins("lpr")

class Printer(object):
    def __init__(self, opts={}):
        """initializes the printer with options"""
        self.options = []
        self.setOptions(opts)
    
    def write(self, text):
        """prints a string"""
        stdin = subprocess.Popen(["lpr", " ".join(self.options)], stdin=subprocess.PIPE).stdin
        stdin.write(text)
        stdin.close()

    def printer_name(self):
        return raw_input('Introduzca el Nombre de la Impresora: ')

    def writeFile(self, file, impresora, size):
        print "entro en el metodo writeFile"
        """prints a file"""        
        args= [
            'gs'                    , 
            '-sDEVICE=eps9high'     , 
            '-sOutputFile=-'        ,
            '-q'                    , 
            '-dBATCH'               , 
            '-dNOPAUSE'             , 
            'mi_archivo.pdf'        ,
            ]
        tamano='media=%s'%size  
        p = subprocess.Popen(args, stdout=subprocess.PIPE)
        q = subprocess.Popen(["lpr", '-P', impresora, " ".join(self.options)], stdin=p.stdout)
        #q = subprocess.Popen(["lpr", '-P', impresora, '-o',tamano,], stdin=p.stdout)
    

    def writeFile_stock(self, file, impresora,size):
        print "entro en el metodo para imprimir el reporte de stock"
        subprocess.Popen(["lpr", '-P', impresora, "-o orientation-requested=5 ", "mi_archivo.pdf", " ".join(self.options),], stdin=subprocess.PIPE)

    def setOption(self, key, value=None):
        if value is None:
            option = "-o %s" % key
        else:
            option = "-o %s=%s" % (key, value)
        self.options.append(option)
    
    def setOptions(self, opts):
        """sets printer options from a dictionary"""
        for (key, value) in opts.items():
            self.setOption(key, value)
            
    def reset(self):
        """puts the printer back in its default state"""
        self.options = []

def conect( cr, uid,file, impresora, page_size,attachment, modelo, id_obj):
    print "la impresora es: ", impresora
    mi_archivo = open('mi_archivo.pdf','wb+')
    mi_archivo.write(file)
    mi_archivo.close
    
    if page_size==False:
        print "no imprime porque no eligio size"
    else:
        if page_size=="letter": #carta
            print"size: carta"
            size='Letter' 
            printerOptions = {
                "cpi": 20                   ,
                "lpi": 12                   ,
                "PageSize":"letter"         ,
                "media":'Letter'            ,
                "fit-to-page":None          ,
            }      
        if page_size=="half_letter": #media hoja
            print"size: media hoja"
            size='halfletter' 
            printerOptions = {
                "cpi": 10                                 ,
                "lpi": 8                                  ,
                "-o orientation-requested":5              ,
            }         
        p = Printer(printerOptions)     
        if impresora==False or impresora=="ninguna":
            print "no eligio una impresora"     
        else:
            print"el modelo es", modelo
            print"el attachment es", attachment
            if modelo=="account.invoice":#solo imprime las facturas que no tienen attachment
                if attachment==True:#no tiene attach
                    pool = pooler.get_pool(cr.dbname)
                    ir_objj = pool.get('account.invoice')
                    invoice = ir_objj.browse(cr, uid, id_obj,context=None)
                    if invoice.state=="open" or invoice.state=="paid": 
                        p.writeFile(mi_archivo, impresora,size) #metodo que imprime
            if modelo=="stock.picking":#para stock imprime el pdf directo
                    p.writeFile_stock(mi_archivo, impresora,size) #metodo que imprime stock   
            if modelo=="voucher.pay.support.wizard":#para los cheques
                p.writeFile(mi_archivo, impresora,size) #metodo que imprime
    
######################################################################################

class _format(report_sxw._format):
    pass

class _float_format(report_sxw._float_format):
    pass

class _int_format(report_sxw._int_format):
    pass
 
class _date_format(report_sxw._date_format):
    pass   

class _dttime_format(report_sxw._dttime_format):
    pass

class browse_record_list(report_sxw.browse_record_list):
    pass
    
class rml_parse(report_sxw.rml_parse):
    pass




class report_sxw(report_sxw.report_sxw):

    #metodo sobreescribed al original, imprime el pdf en la impresora que se selecciono en ir.actions.report.xml      
    def create(self, cr, uid, ids, data, context=None):
        pool = pooler.get_pool(cr.dbname)
        ir_obj = pool.get('ir.actions.report.xml')
        report_xml_ids = ir_obj.search(cr, uid,
                [('report_name', '=', self.name[7:])], context=context)
        if report_xml_ids:
            report_xml = ir_obj.browse(cr, uid, report_xml_ids[0], context=context)
        else:
            title = ''
            rml = tools.file_open(self.tmpl, subdir=None).read()
            report_type= data.get('report_type', 'pdf')
            class a(object):
                def __init__(self, *args, **argv):
                    for key,arg in argv.items():
                        setattr(self, key, arg)
            report_xml = a(title=title, report_type=report_type, report_rml_content=rml, name=title, attachment=False, header=self.header)
        report_type = report_xml.report_type
        ####
        attachment= self.get_attach(cr, uid, ids, data, report_xml, context=None)
        ####
        if report_type in ['sxw','odt']:
            fnct = self.create_source_odt
        elif report_type in ['pdf','raw','html']:
            fnct = self.create_source_pdf
        elif report_type=='html2html':
            fnct = self.create_source_html2html
        else:
            raise 'Unknown Report Type'
        fnct_ret = fnct(cr, uid, ids, data, report_xml, context)
        if not fnct_ret:
            return (False,False)
        #####
        conect(cr, uid,fnct_ret[0], report_xml.printer,report_xml.page_size,attachment,data['model'],data['id'])#metodo que recibe el archivo y la impresora 
        #conect(cr, uid,fnct_ret[0], report_xml.printer_prov,report_xml.page_size,attachment,data['model'],data['id'])#metodo que recibe el archivo y la impresora 
        ######
        
        return fnct_ret
    
    
    #indica si tiene attachment para no imprimir factura
    def get_attach(self, cr, uid, ids, data, report_xml, context=None):
        bandera=False
        if not context:
            context={}
        pool = pooler.get_pool(cr.dbname)
        attach = report_xml.attachment
        if attach: 
            objs = self.getObjects(cr, uid, ids, context)
            results = []
            for obj in objs:
                aname = eval(attach, {'object':obj, 'time':time})
                result = False
                if report_xml.attachment_use and aname and context.get('attachment_use', True):
                    aids = pool.get('ir.attachment').search(cr, uid, [('datas_fname','=',aname+'.pdf'),('res_model','=',self.table),('res_id','=',obj.id)])                  
                    if aids:
                        brow_rec = pool.get('ir.attachment').browse(cr, uid, aids[0])
                        if not brow_rec.datas:
                            continue
                        d = base64.decodestring(brow_rec.datas)
                        results.append((d,'pdf'))
                        continue
                result = self.create_single_pdf(cr, uid, [obj.id], data, report_xml, context)
                if aname:
                    bandera=True #ya que entra solo la primera vez sin attachment
        return bandera


    #metodo que sobreescribe al original, en la impresion de la cabecara del reporte
    def create_single_pdf(self, cr, uid, ids, data, report_xml, context=None):
        print "metodo que sobreescribe a create_single_pdf" 
        if not context:
            context={}
        logo = None
        context = context.copy()
        title = report_xml.name
        rml = report_xml.report_rml_content
        if not rml:
            return False
        rml_parser = self.parser(cr, uid, self.name2, context=context)
        objs = self.getObjects(cr, uid, ids, context)
        rml_parser.set_context(objs, data, ids, report_xml.report_type)
        processed_rml = self.preprocess_rml(etree.XML(rml),report_xml.report_type)
        if report_xml.header: #aqui seria para verificar que el reporte es para  cheque
            rml_parser._add_header(processed_rml,self.header) #aqui se para el rml del cheque
        ################################
        #print "esto es lo que tiene data: ", data
        if data['model']=='voucher.pay.support.wizard':#preguntar si es el modelo voucher.pay.support.wizard, para la impresion de cheques
            pool = pooler.get_pool(cr.dbname)
            ir_objj = pool.get('res.bank.entity')
            #banco = ir_objj.browse(cr, uid, data['context']['bank_id'] , context=None) #no funiona este con GTK
            banco = ir_objj.browse(cr, uid, context['bank_id'] , context=None)
            header=banco.format_h
            self._add_header_bank(processed_rml,header)
        ################################## 
        create_doc = self.generators[report_xml.report_type]
        pdf = create_doc(etree.tostring(processed_rml),rml_parser.localcontext,logo,title.encode('utf8'))
        return (pdf, report_xml.report_type)

    #metodo que sobreescribe al original, agrega el cheque como cabecera en el reporte
    def _add_header_bank(self, rml_dom, bank_header):
        print "entro en el metodo add_header"
        head_dom = etree.XML(bank_header)
        for tag in head_dom:
            found = rml_dom.find('.//'+tag.tag)
            if found is not None and len(found):
                if tag.get('position'):
                    found.append(tag)
                else :
                    found.getparent().replace(found,tag)
        return True
    
    #metodo que sobreescribe al original, gestion de attachment
    def create_source_pdf(self, cr, uid, ids, data, report_xml, context=None):
        bandera=False
        if not context:
            context={}
        pool = pooler.get_pool(cr.dbname)
        attach = report_xml.attachment
        if attach: 
            objs = self.getObjects(cr, uid, ids, context)
            results = []
            for obj in objs:
                aname = eval(attach, {'object':obj, 'time':time})
                result = False
                if report_xml.attachment_use and aname and context.get('attachment_use', True):
                    aids = pool.get('ir.attachment').search(cr, uid, [('datas_fname','=',aname+'.pdf'),('res_model','=',self.table),('res_id','=',obj.id)])                  
                    if aids:
                        brow_rec = pool.get('ir.attachment').browse(cr, uid, aids[0])
                        if not brow_rec.datas:
                            continue
                        d = base64.decodestring(brow_rec.datas)
                        results.append((d,'pdf'))
                        continue
                result = self.create_single_pdf(cr, uid, [obj.id], data, report_xml, context)
                if not result:
                    return False
                try:
                    if aname:
                        bandera=True #ya que entra solo la primera vez sin attachment
                        name = aname+'.'+result[1]
                        pool.get('ir.attachment').create(cr, uid, {
                            'name': aname,
                            'datas': base64.encodestring(result[0]),
                            'datas_fname': name,
                            'res_model': self.table,
                            'res_id': obj.id,
                            }, context=context
                        )
                        cr.commit()
                except Exception,e:
                     import traceback, sys
                     tb_s = reduce(lambda x, y: x+y, traceback.format_exception(sys.exc_type, sys.exc_value, sys.exc_traceback))
                     netsvc.Logger().notifyChannel('report', netsvc.LOG_ERROR,str(e))
                results.append(result) 
            if results:
                if results[0][1]=='pdf':
                    from pyPdf import PdfFileWriter, PdfFileReader
                    output = PdfFileWriter()
                    for r in results:
                        reader = PdfFileReader(cStringIO.StringIO(r[0]))
                        for page in range(reader.getNumPages()):
                            output.addPage(reader.getPage(page))
                    s = cStringIO.StringIO()
                    output.write(s)
                    if bandera==False: #si tiene attachment
                        return self.create_single_pdf_attachment(cr, uid, ids, data, report_xml, context)
                    else:
                        return s.getvalue(), results[0][1]
        return self.create_single_pdf(cr, uid, ids, data, report_xml, context)


    def create_single_pdf_attachment(self, cr, uid, ids, data, report_xml, context=None):
        if not context:
            context={}
        logo = None
        context = context.copy()
        title = report_xml.name
        rml = report_xml.report_rml_content
        if not rml:
            return False
        rml_parser = self.parser(cr, uid, self.name2, context=context)
        objs = self.getObjects(cr, uid, ids, context)
        rml_parser.set_context(objs, data, ids, report_xml.report_type)
        processed_rml = self.preprocess_rml(etree.XML(rml),report_xml.report_type)
        if report_xml.header:
            rml_parser._add_header(processed_rml,self.header)          
        if data['model']=='account.invoice':#es el modelo account.invoice para la impresion de facturas 
            pool2 = pooler.get_pool(cr.dbname)
            att = pool2.get('ir.attachment')
            attach = att.search(cr, uid, [('res_model','=','account.invoice')])
            if len(attach)>0:
                header_attach='''                 
                                <header>                             
                                <pageTemplate>                             
                                    <frame id="first" x1="0.0mm" y1="0.0mm" width="215.0mm" height="215.0mm"/> 
                                        <pageGraphics>                                                         
                                            <place x="80.0mm" y="130.0mm" width="60.0mm" height="10.0mm">
                                                <para>***NO APTO PARA IMPRIMIR***</para>                             
                                            </place>                                                            
                                            <setFont name="Helvetica" size="8"/>                              
                                        </pageGraphics>                             
                                    </pageTemplate>                             
                                </header> 
                                            '''  
           
                self._add_header_bank(processed_rml,header_attach)    
        create_doc = self.generators[report_xml.report_type]
        pdf = create_doc(etree.tostring(processed_rml),rml_parser.localcontext,logo,title.encode('utf8'))
        return (pdf, report_xml.report_type)
